import{S as cm,i as pm,s as hm,e as a,k as h,w,t as n,M as um,c as r,d as t,m as u,a as i,x as k,h as s,b as m,G as e,g,y as b,q as $,o as P,B as F,v as fm,L as ft}from"../../chunks/vendor-hf-doc-builder.js";import{T as Oe}from"../../chunks/Tip-hf-doc-builder.js";import{D as _e}from"../../chunks/Docstring-hf-doc-builder.js";import{C as Qe}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as ht}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as ut}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function mm(x){let d,y,p,f,T;return f=new Qe({props:{code:`from transformers import GPTJModel, GPTJConfig

# Initializing a GPT-J 6B configuration
configuration = GPTJConfig()

# Initializing a model from the configuration
model = GPTJModel(configuration)

# Accessing the model configuration
configuration = model.config`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> GPTJModel, GPTJConfig

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a GPT-J 6B configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = GPTJConfig()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a model from the configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = GPTJModel(configuration)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Accessing the model configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = model.config`}}),{c(){d=a("p"),y=n("Example:"),p=h(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Example:"),c.forEach(t),p=u(l),k(f.$$.fragment,l)},m(l,c){g(l,d,c),e(d,y),g(l,p,c),b(f,l,c),T=!0},p:ft,i(l){T||($(f.$$.fragment,l),T=!0)},o(l){P(f.$$.fragment,l),T=!1},d(l){l&&t(d),l&&t(p),F(f,l)}}}function gm(x){let d,y,p,f,T;return{c(){d=a("p"),y=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),p=a("code"),f=n("Module"),T=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Although the recipe for forward pass needs to be defined within this function, one should call the "),p=r(c,"CODE",{});var j=i(p);f=s(j,"Module"),j.forEach(t),T=s(c,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),c.forEach(t)},m(l,c){g(l,d,c),e(d,y),e(d,p),e(p,f),e(d,T)},d(l){l&&t(d)}}}function _m(x){let d,y,p,f,T,l,c,j;return{c(){d=a("p"),y=n(`This example uses a random model as the real ones are all very big. To get proper results, you should use
EleutherAI/gpt-j-6B instead of hf-internal-testing/tiny-random-gptj. If you get out-of-memory when loading that checkpoint, you can try
adding `),p=a("code"),f=n('device_map="auto"'),T=n(" in the "),l=a("code"),c=n("from_pretrained"),j=n(" call.")},l(z){d=r(z,"P",{});var J=i(d);y=s(J,`This example uses a random model as the real ones are all very big. To get proper results, you should use
EleutherAI/gpt-j-6B instead of hf-internal-testing/tiny-random-gptj. If you get out-of-memory when loading that checkpoint, you can try
adding `),p=r(J,"CODE",{});var C=i(p);f=s(C,'device_map="auto"'),C.forEach(t),T=s(J," in the "),l=r(J,"CODE",{});var D=i(l);c=s(D,"from_pretrained"),D.forEach(t),j=s(J," call."),J.forEach(t)},m(z,J){g(z,d,J),e(d,y),e(d,p),e(p,f),e(d,T),e(d,l),e(l,c),e(d,j)},d(z){z&&t(d)}}}function Tm(x){let d,y,p,f,T;return f=new Qe({props:{code:`from transformers import AutoTokenizer, GPTJModel
import torch

tokenizer = AutoTokenizer.from_pretrained("hf-internal-testing/tiny-random-gptj")
model = GPTJModel.from_pretrained("hf-internal-testing/tiny-random-gptj")

inputs = tokenizer("Hello, my dog is cute", return_tensors="pt")
outputs = model(**inputs)

last_hidden_states = outputs.last_hidden_state`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, GPTJModel
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;hf-internal-testing/tiny-random-gptj&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = GPTJModel.from_pretrained(<span class="hljs-string">&quot;hf-internal-testing/tiny-random-gptj&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span>last_hidden_states = outputs.last_hidden_state`}}),{c(){d=a("p"),y=n("Example:"),p=h(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Example:"),c.forEach(t),p=u(l),k(f.$$.fragment,l)},m(l,c){g(l,d,c),e(d,y),g(l,p,c),b(f,l,c),T=!0},p:ft,i(l){T||($(f.$$.fragment,l),T=!0)},o(l){P(f.$$.fragment,l),T=!1},d(l){l&&t(d),l&&t(p),F(f,l)}}}function ym(x){let d,y,p,f,T;return{c(){d=a("p"),y=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),p=a("code"),f=n("Module"),T=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Although the recipe for forward pass needs to be defined within this function, one should call the "),p=r(c,"CODE",{});var j=i(p);f=s(j,"Module"),j.forEach(t),T=s(c,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),c.forEach(t)},m(l,c){g(l,d,c),e(d,y),e(d,p),e(p,f),e(d,T)},d(l){l&&t(d)}}}function vm(x){let d,y,p,f,T,l,c,j;return{c(){d=a("p"),y=n(`This example uses a random model as the real ones are all very big. To get proper results, you should use
EleutherAI/gpt-j-6B instead of hf-internal-testing/tiny-random-gptj. If you get out-of-memory when loading that checkpoint, you can try
adding `),p=a("code"),f=n('device_map="auto"'),T=n(" in the "),l=a("code"),c=n("from_pretrained"),j=n(" call.")},l(z){d=r(z,"P",{});var J=i(d);y=s(J,`This example uses a random model as the real ones are all very big. To get proper results, you should use
EleutherAI/gpt-j-6B instead of hf-internal-testing/tiny-random-gptj. If you get out-of-memory when loading that checkpoint, you can try
adding `),p=r(J,"CODE",{});var C=i(p);f=s(C,'device_map="auto"'),C.forEach(t),T=s(J," in the "),l=r(J,"CODE",{});var D=i(l);c=s(D,"from_pretrained"),D.forEach(t),j=s(J," call."),J.forEach(t)},m(z,J){g(z,d,J),e(d,y),e(d,p),e(p,f),e(d,T),e(d,l),e(l,c),e(d,j)},d(z){z&&t(d)}}}function wm(x){let d,y,p,f,T;return f=new Qe({props:{code:`import torch
from transformers import AutoTokenizer, GPTJForCausalLM

tokenizer = AutoTokenizer.from_pretrained("hf-internal-testing/tiny-random-gptj")
model = GPTJForCausalLM.from_pretrained("hf-internal-testing/tiny-random-gptj")

inputs = tokenizer("Hello, my dog is cute", return_tensors="pt")
outputs = model(**inputs, labels=inputs["input_ids"])
loss = outputs.loss
logits = outputs.logits`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, GPTJForCausalLM

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;hf-internal-testing/tiny-random-gptj&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = GPTJForCausalLM.from_pretrained(<span class="hljs-string">&quot;hf-internal-testing/tiny-random-gptj&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs, labels=inputs[<span class="hljs-string">&quot;input_ids&quot;</span>])
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = outputs.loss
<span class="hljs-meta">&gt;&gt;&gt; </span>logits = outputs.logits`}}),{c(){d=a("p"),y=n("Example:"),p=h(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Example:"),c.forEach(t),p=u(l),k(f.$$.fragment,l)},m(l,c){g(l,d,c),e(d,y),g(l,p,c),b(f,l,c),T=!0},p:ft,i(l){T||($(f.$$.fragment,l),T=!0)},o(l){P(f.$$.fragment,l),T=!1},d(l){l&&t(d),l&&t(p),F(f,l)}}}function km(x){let d,y,p,f,T;return{c(){d=a("p"),y=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),p=a("code"),f=n("Module"),T=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Although the recipe for forward pass needs to be defined within this function, one should call the "),p=r(c,"CODE",{});var j=i(p);f=s(j,"Module"),j.forEach(t),T=s(c,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),c.forEach(t)},m(l,c){g(l,d,c),e(d,y),e(d,p),e(p,f),e(d,T)},d(l){l&&t(d)}}}function bm(x){let d,y,p,f,T,l,c,j;return{c(){d=a("p"),y=n(`This example uses a random model as the real ones are all very big. To get proper results, you should use
EleutherAI/gpt-j-6B instead of ydshieh/tiny-random-gptj-for-sequence-classification. If you get out-of-memory when loading that checkpoint, you can try
adding `),p=a("code"),f=n('device_map="auto"'),T=n(" in the "),l=a("code"),c=n("from_pretrained"),j=n(" call.")},l(z){d=r(z,"P",{});var J=i(d);y=s(J,`This example uses a random model as the real ones are all very big. To get proper results, you should use
EleutherAI/gpt-j-6B instead of ydshieh/tiny-random-gptj-for-sequence-classification. If you get out-of-memory when loading that checkpoint, you can try
adding `),p=r(J,"CODE",{});var C=i(p);f=s(C,'device_map="auto"'),C.forEach(t),T=s(J," in the "),l=r(J,"CODE",{});var D=i(l);c=s(D,"from_pretrained"),D.forEach(t),j=s(J," call."),J.forEach(t)},m(z,J){g(z,d,J),e(d,y),e(d,p),e(p,f),e(d,T),e(d,l),e(l,c),e(d,j)},d(z){z&&t(d)}}}function $m(x){let d,y,p,f,T;return f=new Qe({props:{code:`import torch
from transformers import AutoTokenizer, GPTJForSequenceClassification

tokenizer = AutoTokenizer.from_pretrained("ydshieh/tiny-random-gptj-for-sequence-classification")
model = GPTJForSequenceClassification.from_pretrained("ydshieh/tiny-random-gptj-for-sequence-classification")

inputs = tokenizer("Hello, my dog is cute", return_tensors="pt")

with torch.no_grad():
    logits = model(**inputs).logits

predicted_class_id = logits.argmax().item()

# To train a model on \`num_labels\` classes, you can pass \`num_labels=num_labels\` to \`.from_pretrained(...)\`
num_labels = len(model.config.id2label)
model = GPTJForSequenceClassification.from_pretrained("ydshieh/tiny-random-gptj-for-sequence-classification", num_labels=num_labels)

labels = torch.tensor([1])
loss = model(**inputs, labels=labels).loss`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, GPTJForSequenceClassification

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;ydshieh/tiny-random-gptj-for-sequence-classification&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = GPTJForSequenceClassification.from_pretrained(<span class="hljs-string">&quot;ydshieh/tiny-random-gptj-for-sequence-classification&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    logits = model(**inputs).logits

<span class="hljs-meta">&gt;&gt;&gt; </span>predicted_class_id = logits.argmax().item()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># To train a model on \`num_labels\` classes, you can pass \`num_labels=num_labels\` to \`.from_pretrained(...)\`</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>num_labels = <span class="hljs-built_in">len</span>(model.config.id2label)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = GPTJForSequenceClassification.from_pretrained(<span class="hljs-string">&quot;ydshieh/tiny-random-gptj-for-sequence-classification&quot;</span>, num_labels=num_labels)

<span class="hljs-meta">&gt;&gt;&gt; </span>labels = torch.tensor([<span class="hljs-number">1</span>])
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = model(**inputs, labels=labels).loss`}}),{c(){d=a("p"),y=n("Example of single-label classification:"),p=h(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Example of single-label classification:"),c.forEach(t),p=u(l),k(f.$$.fragment,l)},m(l,c){g(l,d,c),e(d,y),g(l,p,c),b(f,l,c),T=!0},p:ft,i(l){T||($(f.$$.fragment,l),T=!0)},o(l){P(f.$$.fragment,l),T=!1},d(l){l&&t(d),l&&t(p),F(f,l)}}}function Pm(x){let d,y,p,f,T;return f=new Qe({props:{code:`import torch
from transformers import AutoTokenizer, GPTJForSequenceClassification

tokenizer = AutoTokenizer.from_pretrained("ydshieh/tiny-random-gptj-for-sequence-classification")
model = GPTJForSequenceClassification.from_pretrained("ydshieh/tiny-random-gptj-for-sequence-classification", problem_type="multi_label_classification")

inputs = tokenizer("Hello, my dog is cute", return_tensors="pt")

with torch.no_grad():
    logits = model(**inputs).logits

predicted_class_ids = torch.arange(0, logits.shape[-1])[torch.sigmoid(logits).squeeze(dim=0) > 0.5]

# To train a model on \`num_labels\` classes, you can pass \`num_labels=num_labels\` to \`.from_pretrained(...)\`
num_labels = len(model.config.id2label)
model = GPTJForSequenceClassification.from_pretrained(
    "ydshieh/tiny-random-gptj-for-sequence-classification", num_labels=num_labels, problem_type="multi_label_classification"
)

labels = torch.sum(
    torch.nn.functional.one_hot(predicted_class_ids[None, :].clone(), num_classes=num_labels), dim=1
).to(torch.float)
loss = model(**inputs, labels=labels).loss`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, GPTJForSequenceClassification

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;ydshieh/tiny-random-gptj-for-sequence-classification&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = GPTJForSequenceClassification.from_pretrained(<span class="hljs-string">&quot;ydshieh/tiny-random-gptj-for-sequence-classification&quot;</span>, problem_type=<span class="hljs-string">&quot;multi_label_classification&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    logits = model(**inputs).logits

<span class="hljs-meta">&gt;&gt;&gt; </span>predicted_class_ids = torch.arange(<span class="hljs-number">0</span>, logits.shape[-<span class="hljs-number">1</span>])[torch.sigmoid(logits).squeeze(dim=<span class="hljs-number">0</span>) &gt; <span class="hljs-number">0.5</span>]

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># To train a model on \`num_labels\` classes, you can pass \`num_labels=num_labels\` to \`.from_pretrained(...)\`</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>num_labels = <span class="hljs-built_in">len</span>(model.config.id2label)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = GPTJForSequenceClassification.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;ydshieh/tiny-random-gptj-for-sequence-classification&quot;</span>, num_labels=num_labels, problem_type=<span class="hljs-string">&quot;multi_label_classification&quot;</span>
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>labels = torch.<span class="hljs-built_in">sum</span>(
<span class="hljs-meta">... </span>    torch.nn.functional.one_hot(predicted_class_ids[<span class="hljs-literal">None</span>, :].clone(), num_classes=num_labels), dim=<span class="hljs-number">1</span>
<span class="hljs-meta">... </span>).to(torch.<span class="hljs-built_in">float</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = model(**inputs, labels=labels).loss`}}),{c(){d=a("p"),y=n("Example of multi-label classification:"),p=h(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Example of multi-label classification:"),c.forEach(t),p=u(l),k(f.$$.fragment,l)},m(l,c){g(l,d,c),e(d,y),g(l,p,c),b(f,l,c),T=!0},p:ft,i(l){T||($(f.$$.fragment,l),T=!0)},o(l){P(f.$$.fragment,l),T=!1},d(l){l&&t(d),l&&t(p),F(f,l)}}}function Fm(x){let d,y,p,f,T;return{c(){d=a("p"),y=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),p=a("code"),f=n("Module"),T=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Although the recipe for forward pass needs to be defined within this function, one should call the "),p=r(c,"CODE",{});var j=i(p);f=s(j,"Module"),j.forEach(t),T=s(c,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),c.forEach(t)},m(l,c){g(l,d,c),e(d,y),e(d,p),e(p,f),e(d,T)},d(l){l&&t(d)}}}function jm(x){let d,y,p,f,T,l,c,j;return{c(){d=a("p"),y=n(`This example uses a random model as the real ones are all very big. To get proper results, you should use
EleutherAI/gpt-j-6B instead of hf-internal-testing/tiny-random-gptj. If you get out-of-memory when loading that checkpoint, you can try
adding `),p=a("code"),f=n('device_map="auto"'),T=n(" in the "),l=a("code"),c=n("from_pretrained"),j=n(" call.")},l(z){d=r(z,"P",{});var J=i(d);y=s(J,`This example uses a random model as the real ones are all very big. To get proper results, you should use
EleutherAI/gpt-j-6B instead of hf-internal-testing/tiny-random-gptj. If you get out-of-memory when loading that checkpoint, you can try
adding `),p=r(J,"CODE",{});var C=i(p);f=s(C,'device_map="auto"'),C.forEach(t),T=s(J," in the "),l=r(J,"CODE",{});var D=i(l);c=s(D,"from_pretrained"),D.forEach(t),j=s(J," call."),J.forEach(t)},m(z,J){g(z,d,J),e(d,y),e(d,p),e(p,f),e(d,T),e(d,l),e(l,c),e(d,j)},d(z){z&&t(d)}}}function Em(x){let d,y,p,f,T;return f=new Qe({props:{code:`from transformers import AutoTokenizer, GPTJForQuestionAnswering
import torch

tokenizer = AutoTokenizer.from_pretrained("hf-internal-testing/tiny-random-gptj")
model = GPTJForQuestionAnswering.from_pretrained("hf-internal-testing/tiny-random-gptj")

question, text = "Who was Jim Henson?", "Jim Henson was a nice puppet"

inputs = tokenizer(question, text, return_tensors="pt")
with torch.no_grad():
    outputs = model(**inputs)

answer_start_index = outputs.start_logits.argmax()
answer_end_index = outputs.end_logits.argmax()

predict_answer_tokens = inputs.input_ids[0, answer_start_index : answer_end_index + 1]

# target is "nice puppet"
target_start_index = torch.tensor([14])
target_end_index = torch.tensor([15])

outputs = model(**inputs, start_positions=target_start_index, end_positions=target_end_index)
loss = outputs.loss`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, GPTJForQuestionAnswering
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;hf-internal-testing/tiny-random-gptj&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = GPTJForQuestionAnswering.from_pretrained(<span class="hljs-string">&quot;hf-internal-testing/tiny-random-gptj&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>question, text = <span class="hljs-string">&quot;Who was Jim Henson?&quot;</span>, <span class="hljs-string">&quot;Jim Henson was a nice puppet&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(question, text, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span>answer_start_index = outputs.start_logits.argmax()
<span class="hljs-meta">&gt;&gt;&gt; </span>answer_end_index = outputs.end_logits.argmax()

<span class="hljs-meta">&gt;&gt;&gt; </span>predict_answer_tokens = inputs.input_ids[<span class="hljs-number">0</span>, answer_start_index : answer_end_index + <span class="hljs-number">1</span>]

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># target is &quot;nice puppet&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>target_start_index = torch.tensor([<span class="hljs-number">14</span>])
<span class="hljs-meta">&gt;&gt;&gt; </span>target_end_index = torch.tensor([<span class="hljs-number">15</span>])

<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs, start_positions=target_start_index, end_positions=target_end_index)
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = outputs.loss`}}),{c(){d=a("p"),y=n("Example:"),p=h(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Example:"),c.forEach(t),p=u(l),k(f.$$.fragment,l)},m(l,c){g(l,d,c),e(d,y),g(l,p,c),b(f,l,c),T=!0},p:ft,i(l){T||($(f.$$.fragment,l),T=!0)},o(l){P(f.$$.fragment,l),T=!1},d(l){l&&t(d),l&&t(p),F(f,l)}}}function xm(x){let d,y,p,f,T,l,c,j,z,J,C,D,oe,E,be,H,$e,Te,B,Pe,re,V,Fe,ie,X,je,ye,Q,Ee,le,de,q,A,ue,Y,ve,fe,O,xe,ce,L,Ge,K,Me,Je,R,qe,Ce,S,ze,Z,we,ee,I,ae,N,me,Ae;return{c(){d=a("p"),y=n("TensorFlow models and layers in "),p=a("code"),f=n("transformers"),T=n(" accept two formats as input:"),l=h(),c=a("ul"),j=a("li"),z=n("having all inputs as keyword arguments (like PyTorch models), or"),J=h(),C=a("li"),D=n("having all inputs as a list, tuple or dict in the first positional argument."),oe=h(),E=a("p"),be=n(`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),H=a("code"),$e=n("model.fit()"),Te=n(` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),B=a("code"),Pe=n("model.fit()"),re=n(` supports! If, however, you want to use the second
format outside of Keras methods like `),V=a("code"),Fe=n("fit()"),ie=n(" and "),X=a("code"),je=n("predict()"),ye=n(`, such as when creating your own layers or models with
the Keras `),Q=a("code"),Ee=n("Functional"),le=n(` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),de=h(),q=a("ul"),A=a("li"),ue=n("a single Tensor with "),Y=a("code"),ve=n("input_ids"),fe=n(" only and nothing else: "),O=a("code"),xe=n("model(input_ids)"),ce=h(),L=a("li"),Ge=n(`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),K=a("code"),Me=n("model([input_ids, attention_mask])"),Je=n(" or "),R=a("code"),qe=n("model([input_ids, attention_mask, token_type_ids])"),Ce=h(),S=a("li"),ze=n(`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),Z=a("code"),we=n('model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),ee=h(),I=a("p"),ae=n(`Note that when creating models and layers with
`),N=a("a"),me=n("subclassing"),Ae=n(` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),this.h()},l(v){d=r(v,"P",{});var G=i(d);y=s(G,"TensorFlow models and layers in "),p=r(G,"CODE",{});var Ve=i(p);f=s(Ve,"transformers"),Ve.forEach(t),T=s(G," accept two formats as input:"),G.forEach(t),l=u(v),c=r(v,"UL",{});var ne=i(c);j=r(ne,"LI",{});var pe=i(j);z=s(pe,"having all inputs as keyword arguments (like PyTorch models), or"),pe.forEach(t),J=u(ne),C=r(ne,"LI",{});var Xe=i(C);D=s(Xe,"having all inputs as a list, tuple or dict in the first positional argument."),Xe.forEach(t),ne.forEach(t),oe=u(v),E=r(v,"P",{});var M=i(E);be=s(M,`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),H=r(M,"CODE",{});var Ye=i(H);$e=s(Ye,"model.fit()"),Ye.forEach(t),Te=s(M,` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),B=r(M,"CODE",{});var Ze=i(B);Pe=s(Ze,"model.fit()"),Ze.forEach(t),re=s(M,` supports! If, however, you want to use the second
format outside of Keras methods like `),V=r(M,"CODE",{});var Ne=i(V);Fe=s(Ne,"fit()"),Ne.forEach(t),ie=s(M," and "),X=r(M,"CODE",{});var et=i(X);je=s(et,"predict()"),et.forEach(t),ye=s(M,`, such as when creating your own layers or models with
the Keras `),Q=r(M,"CODE",{});var tt=i(Q);Ee=s(tt,"Functional"),tt.forEach(t),le=s(M,` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),M.forEach(t),de=u(v),q=r(v,"UL",{});var W=i(q);A=r(W,"LI",{});var te=i(A);ue=s(te,"a single Tensor with "),Y=r(te,"CODE",{});var ot=i(Y);ve=s(ot,"input_ids"),ot.forEach(t),fe=s(te," only and nothing else: "),O=r(te,"CODE",{});var He=i(O);xe=s(He,"model(input_ids)"),He.forEach(t),te.forEach(t),ce=u(W),L=r(W,"LI",{});var U=i(L);Ge=s(U,`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),K=r(U,"CODE",{});var ke=i(K);Me=s(ke,"model([input_ids, attention_mask])"),ke.forEach(t),Je=s(U," or "),R=r(U,"CODE",{});var De=i(R);qe=s(De,"model([input_ids, attention_mask, token_type_ids])"),De.forEach(t),U.forEach(t),Ce=u(W),S=r(W,"LI",{});var he=i(S);ze=s(he,`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),Z=r(he,"CODE",{});var nt=i(Z);we=s(nt,'model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),nt.forEach(t),he.forEach(t),W.forEach(t),ee=u(v),I=r(v,"P",{});var se=i(I);ae=s(se,`Note that when creating models and layers with
`),N=r(se,"A",{href:!0,rel:!0});var st=i(N);me=s(st,"subclassing"),st.forEach(t),Ae=s(se,` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),se.forEach(t),this.h()},h(){m(N,"href","https://keras.io/guides/making_new_layers_and_models_via_subclassing/"),m(N,"rel","nofollow")},m(v,G){g(v,d,G),e(d,y),e(d,p),e(p,f),e(d,T),g(v,l,G),g(v,c,G),e(c,j),e(j,z),e(c,J),e(c,C),e(C,D),g(v,oe,G),g(v,E,G),e(E,be),e(E,H),e(H,$e),e(E,Te),e(E,B),e(B,Pe),e(E,re),e(E,V),e(V,Fe),e(E,ie),e(E,X),e(X,je),e(E,ye),e(E,Q),e(Q,Ee),e(E,le),g(v,de,G),g(v,q,G),e(q,A),e(A,ue),e(A,Y),e(Y,ve),e(A,fe),e(A,O),e(O,xe),e(q,ce),e(q,L),e(L,Ge),e(L,K),e(K,Me),e(L,Je),e(L,R),e(R,qe),e(q,Ce),e(q,S),e(S,ze),e(S,Z),e(Z,we),g(v,ee,G),g(v,I,G),e(I,ae),e(I,N),e(N,me),e(I,Ae)},d(v){v&&t(d),v&&t(l),v&&t(c),v&&t(oe),v&&t(E),v&&t(de),v&&t(q),v&&t(ee),v&&t(I)}}}function Gm(x){let d,y,p,f,T;return{c(){d=a("p"),y=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),p=a("code"),f=n("Module"),T=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Although the recipe for forward pass needs to be defined within this function, one should call the "),p=r(c,"CODE",{});var j=i(p);f=s(j,"Module"),j.forEach(t),T=s(c,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),c.forEach(t)},m(l,c){g(l,d,c),e(d,y),e(d,p),e(p,f),e(d,T)},d(l){l&&t(d)}}}function Mm(x){let d,y,p,f,T;return f=new Qe({props:{code:`from transformers import AutoTokenizer, TFGPTJModel
import tensorflow as tf

tokenizer = AutoTokenizer.from_pretrained("EleutherAI/gpt-j-6B")
model = TFGPTJModel.from_pretrained("EleutherAI/gpt-j-6B")

inputs = tokenizer("Hello, my dog is cute", return_tensors="tf")
outputs = model(inputs)

last_hidden_states = outputs.last_hidden_state`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, TFGPTJModel
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> tensorflow <span class="hljs-keyword">as</span> tf

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-j-6B&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TFGPTJModel.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-j-6B&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;tf&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span>last_hidden_states = outputs.last_hidden_state`}}),{c(){d=a("p"),y=n("Example:"),p=h(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Example:"),c.forEach(t),p=u(l),k(f.$$.fragment,l)},m(l,c){g(l,d,c),e(d,y),g(l,p,c),b(f,l,c),T=!0},p:ft,i(l){T||($(f.$$.fragment,l),T=!0)},o(l){P(f.$$.fragment,l),T=!1},d(l){l&&t(d),l&&t(p),F(f,l)}}}function Jm(x){let d,y,p,f,T,l,c,j,z,J,C,D,oe,E,be,H,$e,Te,B,Pe,re,V,Fe,ie,X,je,ye,Q,Ee,le,de,q,A,ue,Y,ve,fe,O,xe,ce,L,Ge,K,Me,Je,R,qe,Ce,S,ze,Z,we,ee,I,ae,N,me,Ae;return{c(){d=a("p"),y=n("TensorFlow models and layers in "),p=a("code"),f=n("transformers"),T=n(" accept two formats as input:"),l=h(),c=a("ul"),j=a("li"),z=n("having all inputs as keyword arguments (like PyTorch models), or"),J=h(),C=a("li"),D=n("having all inputs as a list, tuple or dict in the first positional argument."),oe=h(),E=a("p"),be=n(`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),H=a("code"),$e=n("model.fit()"),Te=n(` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),B=a("code"),Pe=n("model.fit()"),re=n(` supports! If, however, you want to use the second
format outside of Keras methods like `),V=a("code"),Fe=n("fit()"),ie=n(" and "),X=a("code"),je=n("predict()"),ye=n(`, such as when creating your own layers or models with
the Keras `),Q=a("code"),Ee=n("Functional"),le=n(` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),de=h(),q=a("ul"),A=a("li"),ue=n("a single Tensor with "),Y=a("code"),ve=n("input_ids"),fe=n(" only and nothing else: "),O=a("code"),xe=n("model(input_ids)"),ce=h(),L=a("li"),Ge=n(`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),K=a("code"),Me=n("model([input_ids, attention_mask])"),Je=n(" or "),R=a("code"),qe=n("model([input_ids, attention_mask, token_type_ids])"),Ce=h(),S=a("li"),ze=n(`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),Z=a("code"),we=n('model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),ee=h(),I=a("p"),ae=n(`Note that when creating models and layers with
`),N=a("a"),me=n("subclassing"),Ae=n(` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),this.h()},l(v){d=r(v,"P",{});var G=i(d);y=s(G,"TensorFlow models and layers in "),p=r(G,"CODE",{});var Ve=i(p);f=s(Ve,"transformers"),Ve.forEach(t),T=s(G," accept two formats as input:"),G.forEach(t),l=u(v),c=r(v,"UL",{});var ne=i(c);j=r(ne,"LI",{});var pe=i(j);z=s(pe,"having all inputs as keyword arguments (like PyTorch models), or"),pe.forEach(t),J=u(ne),C=r(ne,"LI",{});var Xe=i(C);D=s(Xe,"having all inputs as a list, tuple or dict in the first positional argument."),Xe.forEach(t),ne.forEach(t),oe=u(v),E=r(v,"P",{});var M=i(E);be=s(M,`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),H=r(M,"CODE",{});var Ye=i(H);$e=s(Ye,"model.fit()"),Ye.forEach(t),Te=s(M,` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),B=r(M,"CODE",{});var Ze=i(B);Pe=s(Ze,"model.fit()"),Ze.forEach(t),re=s(M,` supports! If, however, you want to use the second
format outside of Keras methods like `),V=r(M,"CODE",{});var Ne=i(V);Fe=s(Ne,"fit()"),Ne.forEach(t),ie=s(M," and "),X=r(M,"CODE",{});var et=i(X);je=s(et,"predict()"),et.forEach(t),ye=s(M,`, such as when creating your own layers or models with
the Keras `),Q=r(M,"CODE",{});var tt=i(Q);Ee=s(tt,"Functional"),tt.forEach(t),le=s(M,` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),M.forEach(t),de=u(v),q=r(v,"UL",{});var W=i(q);A=r(W,"LI",{});var te=i(A);ue=s(te,"a single Tensor with "),Y=r(te,"CODE",{});var ot=i(Y);ve=s(ot,"input_ids"),ot.forEach(t),fe=s(te," only and nothing else: "),O=r(te,"CODE",{});var He=i(O);xe=s(He,"model(input_ids)"),He.forEach(t),te.forEach(t),ce=u(W),L=r(W,"LI",{});var U=i(L);Ge=s(U,`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),K=r(U,"CODE",{});var ke=i(K);Me=s(ke,"model([input_ids, attention_mask])"),ke.forEach(t),Je=s(U," or "),R=r(U,"CODE",{});var De=i(R);qe=s(De,"model([input_ids, attention_mask, token_type_ids])"),De.forEach(t),U.forEach(t),Ce=u(W),S=r(W,"LI",{});var he=i(S);ze=s(he,`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),Z=r(he,"CODE",{});var nt=i(Z);we=s(nt,'model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),nt.forEach(t),he.forEach(t),W.forEach(t),ee=u(v),I=r(v,"P",{});var se=i(I);ae=s(se,`Note that when creating models and layers with
`),N=r(se,"A",{href:!0,rel:!0});var st=i(N);me=s(st,"subclassing"),st.forEach(t),Ae=s(se,` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),se.forEach(t),this.h()},h(){m(N,"href","https://keras.io/guides/making_new_layers_and_models_via_subclassing/"),m(N,"rel","nofollow")},m(v,G){g(v,d,G),e(d,y),e(d,p),e(p,f),e(d,T),g(v,l,G),g(v,c,G),e(c,j),e(j,z),e(c,J),e(c,C),e(C,D),g(v,oe,G),g(v,E,G),e(E,be),e(E,H),e(H,$e),e(E,Te),e(E,B),e(B,Pe),e(E,re),e(E,V),e(V,Fe),e(E,ie),e(E,X),e(X,je),e(E,ye),e(E,Q),e(Q,Ee),e(E,le),g(v,de,G),g(v,q,G),e(q,A),e(A,ue),e(A,Y),e(Y,ve),e(A,fe),e(A,O),e(O,xe),e(q,ce),e(q,L),e(L,Ge),e(L,K),e(K,Me),e(L,Je),e(L,R),e(R,qe),e(q,Ce),e(q,S),e(S,ze),e(S,Z),e(Z,we),g(v,ee,G),g(v,I,G),e(I,ae),e(I,N),e(N,me),e(I,Ae)},d(v){v&&t(d),v&&t(l),v&&t(c),v&&t(oe),v&&t(E),v&&t(de),v&&t(q),v&&t(ee),v&&t(I)}}}function qm(x){let d,y,p,f,T;return{c(){d=a("p"),y=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),p=a("code"),f=n("Module"),T=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Although the recipe for forward pass needs to be defined within this function, one should call the "),p=r(c,"CODE",{});var j=i(p);f=s(j,"Module"),j.forEach(t),T=s(c,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),c.forEach(t)},m(l,c){g(l,d,c),e(d,y),e(d,p),e(p,f),e(d,T)},d(l){l&&t(d)}}}function Cm(x){let d,y,p,f,T;return f=new Qe({props:{code:`from transformers import AutoTokenizer, TFGPTJForCausalLM
import tensorflow as tf

tokenizer = AutoTokenizer.from_pretrained("EleutherAI/gpt-j-6B")
model = TFGPTJForCausalLM.from_pretrained("EleutherAI/gpt-j-6B")

inputs = tokenizer("Hello, my dog is cute", return_tensors="tf")
outputs = model(inputs)
logits = outputs.logits`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, TFGPTJForCausalLM
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> tensorflow <span class="hljs-keyword">as</span> tf

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-j-6B&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TFGPTJForCausalLM.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-j-6B&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;tf&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(inputs)
<span class="hljs-meta">&gt;&gt;&gt; </span>logits = outputs.logits`}}),{c(){d=a("p"),y=n("Example:"),p=h(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Example:"),c.forEach(t),p=u(l),k(f.$$.fragment,l)},m(l,c){g(l,d,c),e(d,y),g(l,p,c),b(f,l,c),T=!0},p:ft,i(l){T||($(f.$$.fragment,l),T=!0)},o(l){P(f.$$.fragment,l),T=!1},d(l){l&&t(d),l&&t(p),F(f,l)}}}function zm(x){let d,y,p,f,T,l,c,j,z,J,C,D,oe,E,be,H,$e,Te,B,Pe,re,V,Fe,ie,X,je,ye,Q,Ee,le,de,q,A,ue,Y,ve,fe,O,xe,ce,L,Ge,K,Me,Je,R,qe,Ce,S,ze,Z,we,ee,I,ae,N,me,Ae;return{c(){d=a("p"),y=n("TensorFlow models and layers in "),p=a("code"),f=n("transformers"),T=n(" accept two formats as input:"),l=h(),c=a("ul"),j=a("li"),z=n("having all inputs as keyword arguments (like PyTorch models), or"),J=h(),C=a("li"),D=n("having all inputs as a list, tuple or dict in the first positional argument."),oe=h(),E=a("p"),be=n(`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),H=a("code"),$e=n("model.fit()"),Te=n(` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),B=a("code"),Pe=n("model.fit()"),re=n(` supports! If, however, you want to use the second
format outside of Keras methods like `),V=a("code"),Fe=n("fit()"),ie=n(" and "),X=a("code"),je=n("predict()"),ye=n(`, such as when creating your own layers or models with
the Keras `),Q=a("code"),Ee=n("Functional"),le=n(` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),de=h(),q=a("ul"),A=a("li"),ue=n("a single Tensor with "),Y=a("code"),ve=n("input_ids"),fe=n(" only and nothing else: "),O=a("code"),xe=n("model(input_ids)"),ce=h(),L=a("li"),Ge=n(`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),K=a("code"),Me=n("model([input_ids, attention_mask])"),Je=n(" or "),R=a("code"),qe=n("model([input_ids, attention_mask, token_type_ids])"),Ce=h(),S=a("li"),ze=n(`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),Z=a("code"),we=n('model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),ee=h(),I=a("p"),ae=n(`Note that when creating models and layers with
`),N=a("a"),me=n("subclassing"),Ae=n(` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),this.h()},l(v){d=r(v,"P",{});var G=i(d);y=s(G,"TensorFlow models and layers in "),p=r(G,"CODE",{});var Ve=i(p);f=s(Ve,"transformers"),Ve.forEach(t),T=s(G," accept two formats as input:"),G.forEach(t),l=u(v),c=r(v,"UL",{});var ne=i(c);j=r(ne,"LI",{});var pe=i(j);z=s(pe,"having all inputs as keyword arguments (like PyTorch models), or"),pe.forEach(t),J=u(ne),C=r(ne,"LI",{});var Xe=i(C);D=s(Xe,"having all inputs as a list, tuple or dict in the first positional argument."),Xe.forEach(t),ne.forEach(t),oe=u(v),E=r(v,"P",{});var M=i(E);be=s(M,`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),H=r(M,"CODE",{});var Ye=i(H);$e=s(Ye,"model.fit()"),Ye.forEach(t),Te=s(M,` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),B=r(M,"CODE",{});var Ze=i(B);Pe=s(Ze,"model.fit()"),Ze.forEach(t),re=s(M,` supports! If, however, you want to use the second
format outside of Keras methods like `),V=r(M,"CODE",{});var Ne=i(V);Fe=s(Ne,"fit()"),Ne.forEach(t),ie=s(M," and "),X=r(M,"CODE",{});var et=i(X);je=s(et,"predict()"),et.forEach(t),ye=s(M,`, such as when creating your own layers or models with
the Keras `),Q=r(M,"CODE",{});var tt=i(Q);Ee=s(tt,"Functional"),tt.forEach(t),le=s(M,` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),M.forEach(t),de=u(v),q=r(v,"UL",{});var W=i(q);A=r(W,"LI",{});var te=i(A);ue=s(te,"a single Tensor with "),Y=r(te,"CODE",{});var ot=i(Y);ve=s(ot,"input_ids"),ot.forEach(t),fe=s(te," only and nothing else: "),O=r(te,"CODE",{});var He=i(O);xe=s(He,"model(input_ids)"),He.forEach(t),te.forEach(t),ce=u(W),L=r(W,"LI",{});var U=i(L);Ge=s(U,`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),K=r(U,"CODE",{});var ke=i(K);Me=s(ke,"model([input_ids, attention_mask])"),ke.forEach(t),Je=s(U," or "),R=r(U,"CODE",{});var De=i(R);qe=s(De,"model([input_ids, attention_mask, token_type_ids])"),De.forEach(t),U.forEach(t),Ce=u(W),S=r(W,"LI",{});var he=i(S);ze=s(he,`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),Z=r(he,"CODE",{});var nt=i(Z);we=s(nt,'model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),nt.forEach(t),he.forEach(t),W.forEach(t),ee=u(v),I=r(v,"P",{});var se=i(I);ae=s(se,`Note that when creating models and layers with
`),N=r(se,"A",{href:!0,rel:!0});var st=i(N);me=s(st,"subclassing"),st.forEach(t),Ae=s(se,` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),se.forEach(t),this.h()},h(){m(N,"href","https://keras.io/guides/making_new_layers_and_models_via_subclassing/"),m(N,"rel","nofollow")},m(v,G){g(v,d,G),e(d,y),e(d,p),e(p,f),e(d,T),g(v,l,G),g(v,c,G),e(c,j),e(j,z),e(c,J),e(c,C),e(C,D),g(v,oe,G),g(v,E,G),e(E,be),e(E,H),e(H,$e),e(E,Te),e(E,B),e(B,Pe),e(E,re),e(E,V),e(V,Fe),e(E,ie),e(E,X),e(X,je),e(E,ye),e(E,Q),e(Q,Ee),e(E,le),g(v,de,G),g(v,q,G),e(q,A),e(A,ue),e(A,Y),e(Y,ve),e(A,fe),e(A,O),e(O,xe),e(q,ce),e(q,L),e(L,Ge),e(L,K),e(K,Me),e(L,Je),e(L,R),e(R,qe),e(q,Ce),e(q,S),e(S,ze),e(S,Z),e(Z,we),g(v,ee,G),g(v,I,G),e(I,ae),e(I,N),e(N,me),e(I,Ae)},d(v){v&&t(d),v&&t(l),v&&t(c),v&&t(oe),v&&t(E),v&&t(de),v&&t(q),v&&t(ee),v&&t(I)}}}function Am(x){let d,y,p,f,T;return{c(){d=a("p"),y=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),p=a("code"),f=n("Module"),T=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Although the recipe for forward pass needs to be defined within this function, one should call the "),p=r(c,"CODE",{});var j=i(p);f=s(j,"Module"),j.forEach(t),T=s(c,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),c.forEach(t)},m(l,c){g(l,d,c),e(d,y),e(d,p),e(p,f),e(d,T)},d(l){l&&t(d)}}}function Im(x){let d,y,p,f,T;return f=new Qe({props:{code:`from transformers import AutoTokenizer, TFGPTJForSequenceClassification
import tensorflow as tf

tokenizer = AutoTokenizer.from_pretrained("EleutherAI/gpt-j-6B")
model = TFGPTJForSequenceClassification.from_pretrained("EleutherAI/gpt-j-6B")

inputs = tokenizer("Hello, my dog is cute", return_tensors="tf")

logits = model(**inputs).logits

predicted_class_id = int(tf.math.argmax(logits, axis=-1)[0])`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, TFGPTJForSequenceClassification
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> tensorflow <span class="hljs-keyword">as</span> tf

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-j-6B&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TFGPTJForSequenceClassification.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-j-6B&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;tf&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>logits = model(**inputs).logits

<span class="hljs-meta">&gt;&gt;&gt; </span>predicted_class_id = <span class="hljs-built_in">int</span>(tf.math.argmax(logits, axis=-<span class="hljs-number">1</span>)[<span class="hljs-number">0</span>])`}}),{c(){d=a("p"),y=n("Example:"),p=h(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Example:"),c.forEach(t),p=u(l),k(f.$$.fragment,l)},m(l,c){g(l,d,c),e(d,y),g(l,p,c),b(f,l,c),T=!0},p:ft,i(l){T||($(f.$$.fragment,l),T=!0)},o(l){P(f.$$.fragment,l),T=!1},d(l){l&&t(d),l&&t(p),F(f,l)}}}function Lm(x){let d,y;return d=new Qe({props:{code:'# To train a model on `num_labels` classes, you can pass `num_labels=num_labels` to `.from_pretrained(...)`\nnum_labels = len(model.config.id2label)\nmodel = TFGPTJForSequenceClassification.from_pretrained("EleutherAI/gpt-j-6B", num_labels=num_labels)\n\nlabels = tf.constant(1)\nloss = model(**inputs, labels=labels).loss',highlighted:'<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># To train a model on `num_labels` classes, you can pass `num_labels=num_labels` to `.from_pretrained(...)`</span>\n<span class="hljs-meta">&gt;&gt;&gt; </span>num_labels = <span class="hljs-built_in">len</span>(model.config.id2label)\n<span class="hljs-meta">&gt;&gt;&gt; </span>model = TFGPTJForSequenceClassification.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-j-6B&quot;</span>, num_labels=num_labels)\n\n<span class="hljs-meta">&gt;&gt;&gt; </span>labels = tf.constant(<span class="hljs-number">1</span>)\n<span class="hljs-meta">&gt;&gt;&gt; </span>loss = model(**inputs, labels=labels).loss'}}),{c(){w(d.$$.fragment)},l(p){k(d.$$.fragment,p)},m(p,f){b(d,p,f),y=!0},p:ft,i(p){y||($(d.$$.fragment,p),y=!0)},o(p){P(d.$$.fragment,p),y=!1},d(p){F(d,p)}}}function Om(x){let d,y,p,f,T,l,c,j,z,J,C,D,oe,E,be,H,$e,Te,B,Pe,re,V,Fe,ie,X,je,ye,Q,Ee,le,de,q,A,ue,Y,ve,fe,O,xe,ce,L,Ge,K,Me,Je,R,qe,Ce,S,ze,Z,we,ee,I,ae,N,me,Ae;return{c(){d=a("p"),y=n("TensorFlow models and layers in "),p=a("code"),f=n("transformers"),T=n(" accept two formats as input:"),l=h(),c=a("ul"),j=a("li"),z=n("having all inputs as keyword arguments (like PyTorch models), or"),J=h(),C=a("li"),D=n("having all inputs as a list, tuple or dict in the first positional argument."),oe=h(),E=a("p"),be=n(`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),H=a("code"),$e=n("model.fit()"),Te=n(` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),B=a("code"),Pe=n("model.fit()"),re=n(` supports! If, however, you want to use the second
format outside of Keras methods like `),V=a("code"),Fe=n("fit()"),ie=n(" and "),X=a("code"),je=n("predict()"),ye=n(`, such as when creating your own layers or models with
the Keras `),Q=a("code"),Ee=n("Functional"),le=n(` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),de=h(),q=a("ul"),A=a("li"),ue=n("a single Tensor with "),Y=a("code"),ve=n("input_ids"),fe=n(" only and nothing else: "),O=a("code"),xe=n("model(input_ids)"),ce=h(),L=a("li"),Ge=n(`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),K=a("code"),Me=n("model([input_ids, attention_mask])"),Je=n(" or "),R=a("code"),qe=n("model([input_ids, attention_mask, token_type_ids])"),Ce=h(),S=a("li"),ze=n(`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),Z=a("code"),we=n('model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),ee=h(),I=a("p"),ae=n(`Note that when creating models and layers with
`),N=a("a"),me=n("subclassing"),Ae=n(` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),this.h()},l(v){d=r(v,"P",{});var G=i(d);y=s(G,"TensorFlow models and layers in "),p=r(G,"CODE",{});var Ve=i(p);f=s(Ve,"transformers"),Ve.forEach(t),T=s(G," accept two formats as input:"),G.forEach(t),l=u(v),c=r(v,"UL",{});var ne=i(c);j=r(ne,"LI",{});var pe=i(j);z=s(pe,"having all inputs as keyword arguments (like PyTorch models), or"),pe.forEach(t),J=u(ne),C=r(ne,"LI",{});var Xe=i(C);D=s(Xe,"having all inputs as a list, tuple or dict in the first positional argument."),Xe.forEach(t),ne.forEach(t),oe=u(v),E=r(v,"P",{});var M=i(E);be=s(M,`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),H=r(M,"CODE",{});var Ye=i(H);$e=s(Ye,"model.fit()"),Ye.forEach(t),Te=s(M,` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),B=r(M,"CODE",{});var Ze=i(B);Pe=s(Ze,"model.fit()"),Ze.forEach(t),re=s(M,` supports! If, however, you want to use the second
format outside of Keras methods like `),V=r(M,"CODE",{});var Ne=i(V);Fe=s(Ne,"fit()"),Ne.forEach(t),ie=s(M," and "),X=r(M,"CODE",{});var et=i(X);je=s(et,"predict()"),et.forEach(t),ye=s(M,`, such as when creating your own layers or models with
the Keras `),Q=r(M,"CODE",{});var tt=i(Q);Ee=s(tt,"Functional"),tt.forEach(t),le=s(M,` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),M.forEach(t),de=u(v),q=r(v,"UL",{});var W=i(q);A=r(W,"LI",{});var te=i(A);ue=s(te,"a single Tensor with "),Y=r(te,"CODE",{});var ot=i(Y);ve=s(ot,"input_ids"),ot.forEach(t),fe=s(te," only and nothing else: "),O=r(te,"CODE",{});var He=i(O);xe=s(He,"model(input_ids)"),He.forEach(t),te.forEach(t),ce=u(W),L=r(W,"LI",{});var U=i(L);Ge=s(U,`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),K=r(U,"CODE",{});var ke=i(K);Me=s(ke,"model([input_ids, attention_mask])"),ke.forEach(t),Je=s(U," or "),R=r(U,"CODE",{});var De=i(R);qe=s(De,"model([input_ids, attention_mask, token_type_ids])"),De.forEach(t),U.forEach(t),Ce=u(W),S=r(W,"LI",{});var he=i(S);ze=s(he,`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),Z=r(he,"CODE",{});var nt=i(Z);we=s(nt,'model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),nt.forEach(t),he.forEach(t),W.forEach(t),ee=u(v),I=r(v,"P",{});var se=i(I);ae=s(se,`Note that when creating models and layers with
`),N=r(se,"A",{href:!0,rel:!0});var st=i(N);me=s(st,"subclassing"),st.forEach(t),Ae=s(se,` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),se.forEach(t),this.h()},h(){m(N,"href","https://keras.io/guides/making_new_layers_and_models_via_subclassing/"),m(N,"rel","nofollow")},m(v,G){g(v,d,G),e(d,y),e(d,p),e(p,f),e(d,T),g(v,l,G),g(v,c,G),e(c,j),e(j,z),e(c,J),e(c,C),e(C,D),g(v,oe,G),g(v,E,G),e(E,be),e(E,H),e(H,$e),e(E,Te),e(E,B),e(B,Pe),e(E,re),e(E,V),e(V,Fe),e(E,ie),e(E,X),e(X,je),e(E,ye),e(E,Q),e(Q,Ee),e(E,le),g(v,de,G),g(v,q,G),e(q,A),e(A,ue),e(A,Y),e(Y,ve),e(A,fe),e(A,O),e(O,xe),e(q,ce),e(q,L),e(L,Ge),e(L,K),e(K,Me),e(L,Je),e(L,R),e(R,qe),e(q,Ce),e(q,S),e(S,ze),e(S,Z),e(Z,we),g(v,ee,G),g(v,I,G),e(I,ae),e(I,N),e(N,me),e(I,Ae)},d(v){v&&t(d),v&&t(l),v&&t(c),v&&t(oe),v&&t(E),v&&t(de),v&&t(q),v&&t(ee),v&&t(I)}}}function Nm(x){let d,y,p,f,T;return{c(){d=a("p"),y=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),p=a("code"),f=n("Module"),T=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Although the recipe for forward pass needs to be defined within this function, one should call the "),p=r(c,"CODE",{});var j=i(p);f=s(j,"Module"),j.forEach(t),T=s(c,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),c.forEach(t)},m(l,c){g(l,d,c),e(d,y),e(d,p),e(p,f),e(d,T)},d(l){l&&t(d)}}}function Dm(x){let d,y,p,f,T;return f=new Qe({props:{code:`from transformers import AutoTokenizer, TFGPTJForQuestionAnswering
import tensorflow as tf

tokenizer = AutoTokenizer.from_pretrained("EleutherAI/gpt-j-6B")
model = TFGPTJForQuestionAnswering.from_pretrained("EleutherAI/gpt-j-6B")

question, text = "Who was Jim Henson?", "Jim Henson was a nice puppet"

inputs = tokenizer(question, text, return_tensors="tf")
outputs = model(**inputs)

answer_start_index = int(tf.math.argmax(outputs.start_logits, axis=-1)[0])
answer_end_index = int(tf.math.argmax(outputs.end_logits, axis=-1)[0])

predict_answer_tokens = inputs.input_ids[0, answer_start_index : answer_end_index + 1]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, TFGPTJForQuestionAnswering
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> tensorflow <span class="hljs-keyword">as</span> tf

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-j-6B&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TFGPTJForQuestionAnswering.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-j-6B&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>question, text = <span class="hljs-string">&quot;Who was Jim Henson?&quot;</span>, <span class="hljs-string">&quot;Jim Henson was a nice puppet&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(question, text, return_tensors=<span class="hljs-string">&quot;tf&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span>answer_start_index = <span class="hljs-built_in">int</span>(tf.math.argmax(outputs.start_logits, axis=-<span class="hljs-number">1</span>)[<span class="hljs-number">0</span>])
<span class="hljs-meta">&gt;&gt;&gt; </span>answer_end_index = <span class="hljs-built_in">int</span>(tf.math.argmax(outputs.end_logits, axis=-<span class="hljs-number">1</span>)[<span class="hljs-number">0</span>])

<span class="hljs-meta">&gt;&gt;&gt; </span>predict_answer_tokens = inputs.input_ids[<span class="hljs-number">0</span>, answer_start_index : answer_end_index + <span class="hljs-number">1</span>]`}}),{c(){d=a("p"),y=n("Example:"),p=h(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Example:"),c.forEach(t),p=u(l),k(f.$$.fragment,l)},m(l,c){g(l,d,c),e(d,y),g(l,p,c),b(f,l,c),T=!0},p:ft,i(l){T||($(f.$$.fragment,l),T=!0)},o(l){P(f.$$.fragment,l),T=!1},d(l){l&&t(d),l&&t(p),F(f,l)}}}function Sm(x){let d,y;return d=new Qe({props:{code:`# target is "nice puppet"
target_start_index = tf.constant([14])
target_end_index = tf.constant([15])

outputs = model(**inputs, start_positions=target_start_index, end_positions=target_end_index)
loss = tf.math.reduce_mean(outputs.loss)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># target is &quot;nice puppet&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>target_start_index = tf.constant([<span class="hljs-number">14</span>])
<span class="hljs-meta">&gt;&gt;&gt; </span>target_end_index = tf.constant([<span class="hljs-number">15</span>])

<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs, start_positions=target_start_index, end_positions=target_end_index)
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = tf.math.reduce_mean(outputs.loss)`}}),{c(){w(d.$$.fragment)},l(p){k(d.$$.fragment,p)},m(p,f){b(d,p,f),y=!0},p:ft,i(p){y||($(d.$$.fragment,p),y=!0)},o(p){P(d.$$.fragment,p),y=!1},d(p){F(d,p)}}}function Bm(x){let d,y,p,f,T;return{c(){d=a("p"),y=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),p=a("code"),f=n("Module"),T=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Although the recipe for forward pass needs to be defined within this function, one should call the "),p=r(c,"CODE",{});var j=i(p);f=s(j,"Module"),j.forEach(t),T=s(c,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),c.forEach(t)},m(l,c){g(l,d,c),e(d,y),e(d,p),e(p,f),e(d,T)},d(l){l&&t(d)}}}function Wm(x){let d,y,p,f,T;return f=new Qe({props:{code:`from transformers import AutoTokenizer, FlaxGPTJModel

tokenizer = AutoTokenizer.from_pretrained("gptj")
model = FlaxGPTJModel.from_pretrained("gptj")

inputs = tokenizer("Hello, my dog is cute", return_tensors="jax")
outputs = model(**inputs)

last_hidden_states = outputs.last_hidden_state`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, FlaxGPTJModel

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;gptj&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = FlaxGPTJModel.from_pretrained(<span class="hljs-string">&quot;gptj&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;jax&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span>last_hidden_states = outputs.last_hidden_state`}}),{c(){d=a("p"),y=n("Example:"),p=h(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Example:"),c.forEach(t),p=u(l),k(f.$$.fragment,l)},m(l,c){g(l,d,c),e(d,y),g(l,p,c),b(f,l,c),T=!0},p:ft,i(l){T||($(f.$$.fragment,l),T=!0)},o(l){P(f.$$.fragment,l),T=!1},d(l){l&&t(d),l&&t(p),F(f,l)}}}function Um(x){let d,y,p,f,T;return{c(){d=a("p"),y=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),p=a("code"),f=n("Module"),T=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Although the recipe for forward pass needs to be defined within this function, one should call the "),p=r(c,"CODE",{});var j=i(p);f=s(j,"Module"),j.forEach(t),T=s(c,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),c.forEach(t)},m(l,c){g(l,d,c),e(d,y),e(d,p),e(p,f),e(d,T)},d(l){l&&t(d)}}}function Qm(x){let d,y,p,f,T;return f=new Qe({props:{code:`from transformers import AutoTokenizer, FlaxGPTJForCausalLM

tokenizer = AutoTokenizer.from_pretrained("gptj")
model = FlaxGPTJForCausalLM.from_pretrained("gptj")

inputs = tokenizer("Hello, my dog is cute", return_tensors="np")
outputs = model(**inputs)

# retrieve logts for next token
next_token_logits = outputs.logits[:, -1]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, FlaxGPTJForCausalLM

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;gptj&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = FlaxGPTJForCausalLM.from_pretrained(<span class="hljs-string">&quot;gptj&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;np&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># retrieve logts for next token</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>next_token_logits = outputs.logits[:, -<span class="hljs-number">1</span>]`}}),{c(){d=a("p"),y=n("Example:"),p=h(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Example:"),c.forEach(t),p=u(l),k(f.$$.fragment,l)},m(l,c){g(l,d,c),e(d,y),g(l,p,c),b(f,l,c),T=!0},p:ft,i(l){T||($(f.$$.fragment,l),T=!0)},o(l){P(f.$$.fragment,l),T=!1},d(l){l&&t(d),l&&t(p),F(f,l)}}}function Hm(x){let d,y,p,f,T,l,c,j,z,J,C,D,oe,E,be,H,$e,Te,B,Pe,re,V,Fe,ie,X,je,ye,Q,Ee,le,de,q,A,ue,Y,ve,fe,O,xe,ce,L,Ge,K,Me,Je,R,qe,Ce,S,ze,Z,we,ee,I,ae,N,me,Ae,v,G,Ve,ne,pe,Xe,M,Ye,Ze,Ne,et,tt,W,te,ot,He,U,ke,De,he,nt,se,st,Rr,fo,Vi,qs,Xi,Yi,Vr,un,Xr,Cs,Zi,Yr,fn,Zr,Bt,mo,_a,mn,el,Ta,tl,ei,Gt,gn,ol,mt,nl,zs,sl,al,_n,rl,il,As,ll,dl,Is,cl,pl,hl,go,ti,Wt,_o,ya,Tn,ul,va,fl,oi,Mt,yn,ml,vn,gl,wn,_l,Tl,yl,at,kn,vl,Ut,wl,Ls,kl,bl,wa,$l,Pl,Fl,To,jl,yo,El,vo,ni,Qt,wo,ka,bn,xl,ba,Gl,si,gt,$n,Ml,$a,Jl,ql,Pn,Cl,Fn,zl,Al,Il,rt,jn,Ll,Ht,Ol,Os,Nl,Dl,Pa,Sl,Bl,Wl,ko,Ul,bo,Ql,$o,ai,Kt,Po,Fa,En,Hl,ja,Kl,ri,Se,xn,Rl,Ea,Vl,Xl,Ns,Ds,Yl,Zl,ed,_t,td,xa,od,nd,Ga,sd,ad,Ma,rd,id,Ja,ld,dd,cd,Gn,pd,Mn,hd,ud,fd,Ke,Jn,md,Rt,gd,Ss,_d,Td,qa,yd,vd,wd,Fo,kd,jo,bd,Eo,$d,xo,ii,Vt,Go,Ca,qn,Pd,za,Fd,li,Tt,Cn,jd,Xt,Ed,Aa,xd,Gd,Ia,Md,Jd,qd,zn,Cd,An,zd,Ad,Id,it,In,Ld,Yt,Od,Bs,Nd,Dd,La,Sd,Bd,Wd,Mo,Ud,Jo,Qd,qo,di,Zt,Co,Oa,Ln,Hd,Na,Kd,ci,Be,On,Rd,Da,Vd,Xd,Nn,Yd,Ws,Zd,ec,tc,Dn,oc,Sn,nc,sc,ac,zo,rc,wt,Bn,ic,eo,lc,Us,dc,cc,Sa,pc,hc,uc,Ao,fc,Io,pi,to,Lo,Ba,Wn,mc,Wa,gc,hi,We,Un,_c,Ua,Tc,yc,Qn,vc,Qs,wc,kc,bc,Hn,$c,Kn,Pc,Fc,jc,Oo,Ec,kt,Rn,xc,oo,Gc,Hs,Mc,Jc,Qa,qc,Cc,zc,No,Ac,Do,ui,no,So,Ha,Vn,Ic,Ka,Lc,fi,ge,Xn,Oc,Ra,Nc,Dc,Ks,Rs,Sc,Bc,Wc,yt,Uc,Va,Qc,Hc,Xa,Kc,Rc,Ya,Vc,Xc,Za,Yc,Zc,ep,Yn,tp,Vs,op,np,sp,Zn,ap,es,rp,ip,lp,Bo,dp,lt,ts,cp,so,pp,Xs,hp,up,er,fp,mp,gp,Wo,_p,Uo,Tp,Qo,mi,ao,Ho,tr,os,yp,or,vp,gi,Ue,ns,wp,ro,kp,nr,bp,$p,sr,Pp,Fp,jp,ss,Ep,Ys,xp,Gp,Mp,as,Jp,rs,qp,Cp,zp,Ko,Ap,dt,is,Ip,io,Lp,Zs,Op,Np,ar,Dp,Sp,Bp,Ro,Wp,Vo,Up,Xo,_i,lo,Yo,rr,ls,Qp,ir,Hp,Ti,Ie,ds,Kp,lr,Rp,Vp,cs,Xp,ea,Yp,Zp,eh,ps,th,hs,oh,nh,sh,dr,ah,rh,Jt,cr,us,ih,lh,pr,fs,dh,ch,hr,ms,ph,hh,ur,gs,uh,fh,bt,_s,mh,co,gh,fr,_h,Th,mr,yh,vh,wh,Zo,kh,en,yi,po,tn,gr,Ts,bh,_r,$h,vi,Le,ys,Ph,Tr,Fh,jh,vs,Eh,ta,xh,Gh,Mh,ws,Jh,ks,qh,Ch,zh,yr,Ah,Ih,qt,vr,bs,Lh,Oh,wr,$s,Nh,Dh,kr,Ps,Sh,Bh,br,Fs,Wh,Uh,$t,js,Qh,ho,Hh,$r,Kh,Rh,Pr,Vh,Xh,Yh,on,Zh,nn,wi;return l=new ht({}),E=new ht({}),ee=new Qe({props:{code:`from transformers import GPTJForCausalLM
import torch

model = GPTJForCausalLM.from_pretrained(
    "EleutherAI/gpt-j-6B", revision="float16", torch_dtype=torch.float16, low_cpu_mem_usage=True
)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> GPTJForCausalLM
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>model = GPTJForCausalLM.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;EleutherAI/gpt-j-6B&quot;</span>, revision=<span class="hljs-string">&quot;float16&quot;</span>, torch_dtype=torch.float16, low_cpu_mem_usage=<span class="hljs-literal">True</span>
<span class="hljs-meta">... </span>)`}}),he=new ht({}),un=new Qe({props:{code:`from transformers import AutoModelForCausalLM, AutoTokenizer

model = AutoModelForCausalLM.from_pretrained("EleutherAI/gpt-j-6B")
tokenizer = AutoTokenizer.from_pretrained("EleutherAI/gpt-j-6B")

prompt = (
    "In a shocking finding, scientists discovered a herd of unicorns living in a remote, "
    "previously unexplored valley, in the Andes Mountains. Even more surprising to the "
    "researchers was the fact that the unicorns spoke perfect English."
)

input_ids = tokenizer(prompt, return_tensors="pt").input_ids

gen_tokens = model.generate(
    input_ids,
    do_sample=True,
    temperature=0.9,
    max_length=100,
)
gen_text = tokenizer.batch_decode(gen_tokens)[0]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoModelForCausalLM, AutoTokenizer

<span class="hljs-meta">&gt;&gt;&gt; </span>model = AutoModelForCausalLM.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-j-6B&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-j-6B&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = (
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;In a shocking finding, scientists discovered a herd of unicorns living in a remote, &quot;</span>
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;previously unexplored valley, in the Andes Mountains. Even more surprising to the &quot;</span>
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;researchers was the fact that the unicorns spoke perfect English.&quot;</span>
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>input_ids = tokenizer(prompt, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).input_ids

<span class="hljs-meta">&gt;&gt;&gt; </span>gen_tokens = model.generate(
<span class="hljs-meta">... </span>    input_ids,
<span class="hljs-meta">... </span>    do_sample=<span class="hljs-literal">True</span>,
<span class="hljs-meta">... </span>    temperature=<span class="hljs-number">0.9</span>,
<span class="hljs-meta">... </span>    max_length=<span class="hljs-number">100</span>,
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>gen_text = tokenizer.batch_decode(gen_tokens)[<span class="hljs-number">0</span>]`}}),fn=new Qe({props:{code:`from transformers import GPTJForCausalLM, AutoTokenizer
import torch

model = GPTJForCausalLM.from_pretrained("EleutherAI/gpt-j-6B", torch_dtype=torch.float16)
tokenizer = AutoTokenizer.from_pretrained("EleutherAI/gpt-j-6B")

prompt = (
    "In a shocking finding, scientists discovered a herd of unicorns living in a remote, "
    "previously unexplored valley, in the Andes Mountains. Even more surprising to the "
    "researchers was the fact that the unicorns spoke perfect English."
)

input_ids = tokenizer(prompt, return_tensors="pt").input_ids

gen_tokens = model.generate(
    input_ids,
    do_sample=True,
    temperature=0.9,
    max_length=100,
)
gen_text = tokenizer.batch_decode(gen_tokens)[0]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> GPTJForCausalLM, AutoTokenizer
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>model = GPTJForCausalLM.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-j-6B&quot;</span>, torch_dtype=torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-j-6B&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = (
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;In a shocking finding, scientists discovered a herd of unicorns living in a remote, &quot;</span>
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;previously unexplored valley, in the Andes Mountains. Even more surprising to the &quot;</span>
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;researchers was the fact that the unicorns spoke perfect English.&quot;</span>
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>input_ids = tokenizer(prompt, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).input_ids

<span class="hljs-meta">&gt;&gt;&gt; </span>gen_tokens = model.generate(
<span class="hljs-meta">... </span>    input_ids,
<span class="hljs-meta">... </span>    do_sample=<span class="hljs-literal">True</span>,
<span class="hljs-meta">... </span>    temperature=<span class="hljs-number">0.9</span>,
<span class="hljs-meta">... </span>    max_length=<span class="hljs-number">100</span>,
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>gen_text = tokenizer.batch_decode(gen_tokens)[<span class="hljs-number">0</span>]`}}),mn=new ht({}),gn=new _e({props:{name:"class transformers.GPTJConfig",anchor:"transformers.GPTJConfig",parameters:[{name:"vocab_size",val:" = 50400"},{name:"n_positions",val:" = 2048"},{name:"n_embd",val:" = 4096"},{name:"n_layer",val:" = 28"},{name:"n_head",val:" = 16"},{name:"rotary_dim",val:" = 64"},{name:"n_inner",val:" = None"},{name:"activation_function",val:" = 'gelu_new'"},{name:"resid_pdrop",val:" = 0.0"},{name:"embd_pdrop",val:" = 0.0"},{name:"attn_pdrop",val:" = 0.0"},{name:"layer_norm_epsilon",val:" = 1e-05"},{name:"initializer_range",val:" = 0.02"},{name:"scale_attn_weights",val:" = True"},{name:"use_cache",val:" = True"},{name:"bos_token_id",val:" = 50256"},{name:"eos_token_id",val:" = 50256"},{name:"tie_word_embeddings",val:" = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.GPTJConfig.vocab_size",description:`<strong>vocab_size</strong> (<code>int</code>, <em>optional</em>, defaults to 50400) &#x2014;
Vocabulary size of the GPT-J model. Defines the number of different tokens that can be represented by the
<code>inputs_ids</code> passed when calling <a href="/docs/transformers/v4.26.0/en/model_doc/gptj#transformers.GPTJModel">GPTJModel</a>.`,name:"vocab_size"},{anchor:"transformers.GPTJConfig.n_positions",description:`<strong>n_positions</strong> (<code>int</code>, <em>optional</em>, defaults to 2048) &#x2014;
The maximum sequence length that this model might ever be used with. Typically set this to something large
just in case (e.g., 512 or 1024 or 2048).`,name:"n_positions"},{anchor:"transformers.GPTJConfig.n_embd",description:`<strong>n_embd</strong> (<code>int</code>, <em>optional</em>, defaults to 4096) &#x2014;
Dimensionality of the embeddings and hidden states.`,name:"n_embd"},{anchor:"transformers.GPTJConfig.n_layer",description:`<strong>n_layer</strong> (<code>int</code>, <em>optional</em>, defaults to 28) &#x2014;
Number of hidden layers in the Transformer encoder.`,name:"n_layer"},{anchor:"transformers.GPTJConfig.n_head",description:`<strong>n_head</strong> (<code>int</code>, <em>optional</em>, defaults to 16) &#x2014;
Number of attention heads for each attention layer in the Transformer encoder.`,name:"n_head"},{anchor:"transformers.GPTJConfig.rotary_dim",description:`<strong>rotary_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 64) &#x2014;
Number of dimensions in the embedding that Rotary Position Embedding is applied to.`,name:"rotary_dim"},{anchor:"transformers.GPTJConfig.n_inner",description:`<strong>n_inner</strong> (<code>int</code>, <em>optional</em>, defaults to None) &#x2014;
Dimensionality of the inner feed-forward layers. <code>None</code> will set it to 4 times n_embd`,name:"n_inner"},{anchor:"transformers.GPTJConfig.activation_function",description:`<strong>activation_function</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;gelu_new&quot;</code>) &#x2014;
Activation function, to be selected in the list <code>[&quot;relu&quot;, &quot;silu&quot;, &quot;gelu&quot;, &quot;tanh&quot;, &quot;gelu_new&quot;]</code>.`,name:"activation_function"},{anchor:"transformers.GPTJConfig.resid_pdrop",description:`<strong>resid_pdrop</strong> (<code>float</code>, <em>optional</em>, defaults to 0.1) &#x2014;
The dropout probability for all fully connected layers in the embeddings, encoder, and pooler.`,name:"resid_pdrop"},{anchor:"transformers.GPTJConfig.embd_pdrop",description:`<strong>embd_pdrop</strong> (<code>int</code>, <em>optional</em>, defaults to 0.1) &#x2014;
The dropout ratio for the embeddings.`,name:"embd_pdrop"},{anchor:"transformers.GPTJConfig.attn_pdrop",description:`<strong>attn_pdrop</strong> (<code>float</code>, <em>optional</em>, defaults to 0.1) &#x2014;
The dropout ratio for the attention.`,name:"attn_pdrop"},{anchor:"transformers.GPTJConfig.layer_norm_epsilon",description:`<strong>layer_norm_epsilon</strong> (<code>float</code>, <em>optional</em>, defaults to 1e-5) &#x2014;
The epsilon to use in the layer normalization layers.`,name:"layer_norm_epsilon"},{anchor:"transformers.GPTJConfig.initializer_range",description:`<strong>initializer_range</strong> (<code>float</code>, <em>optional</em>, defaults to 0.02) &#x2014;
The standard deviation of the truncated_normal_initializer for initializing all weight matrices.`,name:"initializer_range"},{anchor:"transformers.GPTJConfig.scale_attn_weights",description:`<strong>scale_attn_weights</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Scale attention weights by dividing by sqrt(hidden_size).`,name:"scale_attn_weights"},{anchor:"transformers.GPTJConfig.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not the model should return the last key/values attentions (not used by all models).`,name:"use_cache"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/gptj/configuration_gptj.py#L33"}}),go=new ut({props:{anchor:"transformers.GPTJConfig.example",$$slots:{default:[mm]},$$scope:{ctx:x}}}),Tn=new ht({}),yn=new _e({props:{name:"class transformers.GPTJModel",anchor:"transformers.GPTJModel",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.GPTJModel.config",description:`<strong>config</strong> (<a href="/docs/transformers/v4.26.0/en/model_doc/gptj#transformers.GPTJConfig">GPTJConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/v4.26.0/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/gptj/modeling_gptj.py#L473"}}),kn=new _e({props:{name:"forward",anchor:"transformers.GPTJModel.forward",parameters:[{name:"input_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"past_key_values",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.Tensor]]] = None"},{name:"attention_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"token_type_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"position_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"head_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"inputs_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.GPTJModel.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/v4.26.0/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/v4.26.0/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/v4.26.0/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.GPTJModel.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.GPTJModel.forward.token_type_ids",description:`<strong>token_type_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.GPTJModel.forward.position_ids",description:`<strong>position_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.n_positions - 1]</code>.</p>
<p><a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.GPTJModel.forward.head_mask",description:`<strong>head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_attention_heads,)</code> or <code>(n_layer, num_attention_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.GPTJModel.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_dim)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <em>input_ids</em> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.GPTJModel.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.GPTJModel.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.GPTJModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/v4.26.0/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/gptj/modeling_gptj.py#L529",returnDescription:`
<p>A <a
  href="/docs/transformers/v4.26.0/en/main_classes/output#transformers.modeling_outputs.BaseModelOutputWithPast"
>transformers.modeling_outputs.BaseModelOutputWithPast</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/v4.26.0/en/model_doc/gptj#transformers.GPTJConfig"
>GPTJConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the model.</p>
<p>If <code>past_key_values</code> is used only the last hidden-state of the sequences of shape <code>(batch_size, 1, hidden_size)</code> is output.</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 Tuple of <code>tuple(torch.FloatTensor)</code> of length <code>config.n_layers</code>, with each tuple having 2 tensors of shape
<code>(batch_size, num_heads, sequence_length, embed_size_per_head)</code>) and optionally if
<code>config.is_encoder_decoder=True</code> 2 additional tensors of shape <code>(batch_size, num_heads, encoder_sequence_length, embed_size_per_head)</code>.</p>
<p>Contains pre-computed hidden-states (key and values in the self-attention blocks and optionally if
<code>config.is_encoder_decoder=True</code> in the cross-attention blocks) that can be used (see <code>past_key_values</code>
input) to speed up sequential decoding.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/v4.26.0/en/main_classes/output#transformers.modeling_outputs.BaseModelOutputWithPast"
>transformers.modeling_outputs.BaseModelOutputWithPast</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),To=new Oe({props:{$$slots:{default:[gm]},$$scope:{ctx:x}}}),yo=new Oe({props:{warning:!0,$$slots:{default:[_m]},$$scope:{ctx:x}}}),vo=new ut({props:{anchor:"transformers.GPTJModel.forward.example",$$slots:{default:[Tm]},$$scope:{ctx:x}}}),bn=new ht({}),$n=new _e({props:{name:"class transformers.GPTJForCausalLM",anchor:"transformers.GPTJForCausalLM",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.GPTJForCausalLM.config",description:`<strong>config</strong> (<a href="/docs/transformers/v4.26.0/en/model_doc/gptj#transformers.GPTJConfig">GPTJConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/v4.26.0/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/gptj/modeling_gptj.py#L714"}}),jn=new _e({props:{name:"forward",anchor:"transformers.GPTJForCausalLM.forward",parameters:[{name:"input_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"past_key_values",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.Tensor]]] = None"},{name:"attention_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"token_type_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"position_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"head_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"inputs_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"labels",val:": typing.Optional[torch.LongTensor] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.GPTJForCausalLM.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/v4.26.0/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/v4.26.0/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/v4.26.0/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.GPTJForCausalLM.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.GPTJForCausalLM.forward.token_type_ids",description:`<strong>token_type_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.GPTJForCausalLM.forward.position_ids",description:`<strong>position_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.n_positions - 1]</code>.</p>
<p><a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.GPTJForCausalLM.forward.head_mask",description:`<strong>head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_attention_heads,)</code> or <code>(n_layer, num_attention_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.GPTJForCausalLM.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_dim)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <em>input_ids</em> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.GPTJForCausalLM.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.GPTJForCausalLM.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.GPTJForCausalLM.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/v4.26.0/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.GPTJForCausalLM.forward.labels",description:`<strong>labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Labels for language modeling. Note that the labels <strong>are shifted</strong> inside the model, i.e. you can set
<code>labels = input_ids</code> Indices are selected in <code>[-100, 0, ..., config.vocab_size]</code> All labels set to <code>-100</code>
are ignored (masked), the loss is only computed for labels in <code>[0, ..., config.vocab_size]</code>`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/gptj/modeling_gptj.py#L783",returnDescription:`
<p>A <a
  href="/docs/transformers/v4.26.0/en/main_classes/output#transformers.modeling_outputs.CausalLMOutputWithPast"
>transformers.modeling_outputs.CausalLMOutputWithPast</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/v4.26.0/en/model_doc/gptj#transformers.GPTJConfig"
>GPTJConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Language modeling loss (for next-token prediction).</p>
</li>
<li>
<p><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head (scores for each vocabulary token before SoftMax).</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 Tuple of <code>tuple(torch.FloatTensor)</code> of length <code>config.n_layers</code>, with each tuple having 2 tensors of shape
<code>(batch_size, num_heads, sequence_length, embed_size_per_head)</code>)</p>
<p>Contains pre-computed hidden-states (key and values in the self-attention blocks) that can be used (see
<code>past_key_values</code> input) to speed up sequential decoding.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/v4.26.0/en/main_classes/output#transformers.modeling_outputs.CausalLMOutputWithPast"
>transformers.modeling_outputs.CausalLMOutputWithPast</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),ko=new Oe({props:{$$slots:{default:[ym]},$$scope:{ctx:x}}}),bo=new Oe({props:{warning:!0,$$slots:{default:[vm]},$$scope:{ctx:x}}}),$o=new ut({props:{anchor:"transformers.GPTJForCausalLM.forward.example",$$slots:{default:[wm]},$$scope:{ctx:x}}}),En=new ht({}),xn=new _e({props:{name:"class transformers.GPTJForSequenceClassification",anchor:"transformers.GPTJForSequenceClassification",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.GPTJForSequenceClassification.config",description:`<strong>config</strong> (<a href="/docs/transformers/v4.26.0/en/model_doc/gptj#transformers.GPTJConfig">GPTJConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/v4.26.0/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/gptj/modeling_gptj.py#L889"}}),Jn=new _e({props:{name:"forward",anchor:"transformers.GPTJForSequenceClassification.forward",parameters:[{name:"input_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"past_key_values",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.Tensor]]] = None"},{name:"attention_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"token_type_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"position_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"head_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"inputs_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"labels",val:": typing.Optional[torch.LongTensor] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.GPTJForSequenceClassification.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/v4.26.0/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/v4.26.0/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/v4.26.0/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.GPTJForSequenceClassification.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.GPTJForSequenceClassification.forward.token_type_ids",description:`<strong>token_type_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.GPTJForSequenceClassification.forward.position_ids",description:`<strong>position_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.n_positions - 1]</code>.</p>
<p><a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.GPTJForSequenceClassification.forward.head_mask",description:`<strong>head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_attention_heads,)</code> or <code>(n_layer, num_attention_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.GPTJForSequenceClassification.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_dim)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <em>input_ids</em> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.GPTJForSequenceClassification.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.GPTJForSequenceClassification.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.GPTJForSequenceClassification.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/v4.26.0/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.GPTJForSequenceClassification.forward.labels",description:`<strong>labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for computing the sequence classification/regression loss. Indices should be in <code>[0, ..., config.num_labels - 1]</code>. If <code>config.num_labels == 1</code> a regression loss is computed (Mean-Square loss), If
<code>config.num_labels &gt; 1</code> a classification loss is computed (Cross-Entropy).`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/gptj/modeling_gptj.py#L905",returnDescription:`
<p>A <code>transformers.modeling_outputs.SequenceClassifierOutputWithPast</code> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/v4.26.0/en/model_doc/gptj#transformers.GPTJConfig"
>GPTJConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Classification (or regression if config.num_labels==1) loss.</p>
</li>
<li>
<p><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, config.num_labels)</code>) \u2014 Classification (or regression if config.num_labels==1) scores (before SoftMax).</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 Tuple of <code>tuple(torch.FloatTensor)</code> of length <code>config.n_layers</code>, with each tuple having 2 tensors of shape
<code>(batch_size, num_heads, sequence_length, embed_size_per_head)</code>)</p>
<p>Contains pre-computed hidden-states (key and values in the self-attention blocks) that can be used (see
<code>past_key_values</code> input) to speed up sequential decoding.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><code>transformers.modeling_outputs.SequenceClassifierOutputWithPast</code> or <code>tuple(torch.FloatTensor)</code></p>
`}}),Fo=new Oe({props:{$$slots:{default:[km]},$$scope:{ctx:x}}}),jo=new Oe({props:{warning:!0,$$slots:{default:[bm]},$$scope:{ctx:x}}}),Eo=new ut({props:{anchor:"transformers.GPTJForSequenceClassification.forward.example",$$slots:{default:[$m]},$$scope:{ctx:x}}}),xo=new ut({props:{anchor:"transformers.GPTJForSequenceClassification.forward.example-2",$$slots:{default:[Pm]},$$scope:{ctx:x}}}),qn=new ht({}),Cn=new _e({props:{name:"class transformers.GPTJForQuestionAnswering",anchor:"transformers.GPTJForQuestionAnswering",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.GPTJForQuestionAnswering.config",description:`<strong>config</strong> (<a href="/docs/transformers/v4.26.0/en/model_doc/gptj#transformers.GPTJConfig">GPTJConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/v4.26.0/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/gptj/modeling_gptj.py#L1014"}}),In=new _e({props:{name:"forward",anchor:"transformers.GPTJForQuestionAnswering.forward",parameters:[{name:"input_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"attention_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"token_type_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"position_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"head_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"inputs_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"start_positions",val:": typing.Optional[torch.LongTensor] = None"},{name:"end_positions",val:": typing.Optional[torch.LongTensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.GPTJForQuestionAnswering.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/v4.26.0/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/v4.26.0/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/v4.26.0/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.GPTJForQuestionAnswering.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.GPTJForQuestionAnswering.forward.token_type_ids",description:`<strong>token_type_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.GPTJForQuestionAnswering.forward.position_ids",description:`<strong>position_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.n_positions - 1]</code>.</p>
<p><a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.GPTJForQuestionAnswering.forward.head_mask",description:`<strong>head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_attention_heads,)</code> or <code>(n_layer, num_attention_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.GPTJForQuestionAnswering.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_dim)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <em>input_ids</em> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.GPTJForQuestionAnswering.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.GPTJForQuestionAnswering.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.GPTJForQuestionAnswering.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/v4.26.0/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.GPTJForQuestionAnswering.forward.start_positions",description:`<strong>start_positions</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for position (index) of the start of the labelled span for computing the token classification loss.
Positions are clamped to the length of the sequence (<code>sequence_length</code>). Position outside of the sequence
are not taken into account for computing the loss.`,name:"start_positions"},{anchor:"transformers.GPTJForQuestionAnswering.forward.end_positions",description:`<strong>end_positions</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for position (index) of the end of the labelled span for computing the token classification loss.
Positions are clamped to the length of the sequence (<code>sequence_length</code>). Position outside of the sequence
are not taken into account for computing the loss.`,name:"end_positions"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/gptj/modeling_gptj.py#L1030",returnDescription:`
<p>A <a
  href="/docs/transformers/v4.26.0/en/main_classes/output#transformers.modeling_outputs.QuestionAnsweringModelOutput"
>transformers.modeling_outputs.QuestionAnsweringModelOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/v4.26.0/en/model_doc/gptj#transformers.GPTJConfig"
>GPTJConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Total span extraction loss is the sum of a Cross-Entropy for the start and end positions.</p>
</li>
<li>
<p><strong>start_logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>) \u2014 Span-start scores (before SoftMax).</p>
</li>
<li>
<p><strong>end_logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>) \u2014 Span-end scores (before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/v4.26.0/en/main_classes/output#transformers.modeling_outputs.QuestionAnsweringModelOutput"
>transformers.modeling_outputs.QuestionAnsweringModelOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),Mo=new Oe({props:{$$slots:{default:[Fm]},$$scope:{ctx:x}}}),Jo=new Oe({props:{warning:!0,$$slots:{default:[jm]},$$scope:{ctx:x}}}),qo=new ut({props:{anchor:"transformers.GPTJForQuestionAnswering.forward.example",$$slots:{default:[Em]},$$scope:{ctx:x}}}),Ln=new ht({}),On=new _e({props:{name:"class transformers.TFGPTJModel",anchor:"transformers.TFGPTJModel",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TFGPTJModel.config",description:`<strong>config</strong> (<a href="/docs/transformers/v4.26.0/en/model_doc/gptj#transformers.GPTJConfig">GPTJConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/v4.26.0/en/main_classes/model#transformers.TFPreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/gptj/modeling_tf_gptj.py#L658"}}),zo=new Oe({props:{$$slots:{default:[xm]},$$scope:{ctx:x}}}),Bn=new _e({props:{name:"call",anchor:"transformers.TFGPTJModel.call",parameters:[{name:"input_ids",val:": typing.Union[typing.List[tensorflow.python.framework.ops.Tensor], typing.List[numpy.ndarray], typing.List[keras.engine.keras_tensor.KerasTensor], typing.Dict[str, tensorflow.python.framework.ops.Tensor], typing.Dict[str, numpy.ndarray], typing.Dict[str, keras.engine.keras_tensor.KerasTensor], tensorflow.python.framework.ops.Tensor, numpy.ndarray, keras.engine.keras_tensor.KerasTensor, NoneType] = None"},{name:"past_key_values",val:": typing.Union[typing.Tuple[typing.Tuple[typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor]]], NoneType] = None"},{name:"attention_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"token_type_ids",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"position_ids",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"head_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"inputs_embeds",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"training",val:": typing.Optional[bool] = False"}],parametersDescription:[{anchor:"transformers.TFGPTJModel.call.input_ids",description:`<strong>input_ids</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, input_ids_length)</code>) &#x2014;
<code>input_ids_length</code> = <code>sequence_length</code> if <code>past</code> is <code>None</code> else <code>past[0].shape[-2]</code> (<code>sequence_length</code> of
input past key value states). Indices of input sequence tokens in the vocabulary.</p>
<p>If <code>past</code> is used, only input IDs that do not have their past calculated should be passed as <code>input_ids</code>.</p>
<p>Indices can be obtained using <a href="/docs/transformers/v4.26.0/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/v4.26.0/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> and
<a href="/docs/transformers/v4.26.0/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.TFGPTJModel.call.past_key_values",description:`<strong>past_key_values</strong> (<code>List[tf.Tensor]</code> of length <code>config.n_layers</code>) &#x2014;
Contains pre-computed hidden-states (key and values in the attention blocks) as computed by the model (see
<code>past</code> output below). Can be used to speed up sequential decoding. The token ids which have their past
given to this model should not be passed as input ids as they have already been computed.`,name:"past_key_values"},{anchor:"transformers.TFGPTJModel.call.attention_mask",description:`<strong>attention_mask</strong> (<code>tf.Tensor</code> or <code>Numpy array</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.TFGPTJModel.call.token_type_ids",description:`<strong>token_type_ids</strong> (<code>tf.Tensor</code> or <code>Numpy array</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.TFGPTJModel.call.position_ids",description:`<strong>position_ids</strong> (<code>tf.Tensor</code> or <code>Numpy array</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>.</p>
<p><a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.TFGPTJModel.call.head_mask",description:`<strong>head_mask</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.TFGPTJModel.call.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.TFGPTJModel.call.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail. This argument can be used only in eager mode, in graph mode the value in the
config will be used instead.`,name:"output_attentions"},{anchor:"transformers.TFGPTJModel.call.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail. This argument can be used only in eager mode, in graph mode the value in the config will be
used instead.`,name:"output_hidden_states"},{anchor:"transformers.TFGPTJModel.call.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/v4.26.0/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple. This argument can be used
in eager mode, in graph mode the value will always be set to True.`,name:"return_dict"},{anchor:"transformers.TFGPTJModel.call.training",description:`<strong>training</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to use the model in training mode (some modules like dropout modules have different
behaviors between training and evaluation).`,name:"training"},{anchor:"transformers.TFGPTJModel.call.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
If set to <code>True</code>, <code>past_key_values</code> key value states are returned and can be used to speed up decoding (see
<code>past</code>). Set to <code>False</code> during training, <code>True</code> during generation`,name:"use_cache"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/gptj/modeling_tf_gptj.py#L663",returnDescription:`
<p>A <a
  href="/docs/transformers/v4.26.0/en/main_classes/output#transformers.modeling_tf_outputs.TFBaseModelOutputWithPast"
>transformers.modeling_tf_outputs.TFBaseModelOutputWithPast</a> or a tuple of <code>tf.Tensor</code> (if
<code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various elements depending on the
configuration (<a
  href="/docs/transformers/v4.26.0/en/model_doc/gptj#transformers.GPTJConfig"
>GPTJConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>last_hidden_state</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the model.</p>
<p>If <code>past_key_values</code> is used only the last hidden-state of the sequences of shape <code>(batch_size, 1, hidden_size)</code> is output.</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>List[tf.Tensor]</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 List of <code>tf.Tensor</code> of length <code>config.n_layers</code>, with each tensor of shape <code>(2, batch_size, num_heads, sequence_length, embed_size_per_head)</code>).</p>
<p>Contains pre-computed hidden-states (key and values in the attention blocks) that can be used (see
<code>past_key_values</code> input) to speed up sequential decoding.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/v4.26.0/en/main_classes/output#transformers.modeling_tf_outputs.TFBaseModelOutputWithPast"
>transformers.modeling_tf_outputs.TFBaseModelOutputWithPast</a> or <code>tuple(tf.Tensor)</code></p>
`}}),Ao=new Oe({props:{$$slots:{default:[Gm]},$$scope:{ctx:x}}}),Io=new ut({props:{anchor:"transformers.TFGPTJModel.call.example",$$slots:{default:[Mm]},$$scope:{ctx:x}}}),Wn=new ht({}),Un=new _e({props:{name:"class transformers.TFGPTJForCausalLM",anchor:"transformers.TFGPTJForCausalLM",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TFGPTJForCausalLM.config",description:`<strong>config</strong> (<a href="/docs/transformers/v4.26.0/en/model_doc/gptj#transformers.GPTJConfig">GPTJConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/v4.26.0/en/main_classes/model#transformers.TFPreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/gptj/modeling_tf_gptj.py#L727"}}),Oo=new Oe({props:{$$slots:{default:[Jm]},$$scope:{ctx:x}}}),Rn=new _e({props:{name:"call",anchor:"transformers.TFGPTJForCausalLM.call",parameters:[{name:"input_ids",val:": typing.Union[typing.List[tensorflow.python.framework.ops.Tensor], typing.List[numpy.ndarray], typing.List[keras.engine.keras_tensor.KerasTensor], typing.Dict[str, tensorflow.python.framework.ops.Tensor], typing.Dict[str, numpy.ndarray], typing.Dict[str, keras.engine.keras_tensor.KerasTensor], tensorflow.python.framework.ops.Tensor, numpy.ndarray, keras.engine.keras_tensor.KerasTensor, NoneType] = None"},{name:"past_key_values",val:": typing.Union[typing.Tuple[typing.Tuple[typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor]]], NoneType] = None"},{name:"attention_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"token_type_ids",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"position_ids",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"head_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"inputs_embeds",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"labels",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"training",val:": typing.Optional[bool] = False"}],parametersDescription:[{anchor:"transformers.TFGPTJForCausalLM.call.input_ids",description:`<strong>input_ids</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, input_ids_length)</code>) &#x2014;
<code>input_ids_length</code> = <code>sequence_length</code> if <code>past</code> is <code>None</code> else <code>past[0].shape[-2]</code> (<code>sequence_length</code> of
input past key value states). Indices of input sequence tokens in the vocabulary.</p>
<p>If <code>past</code> is used, only input IDs that do not have their past calculated should be passed as <code>input_ids</code>.</p>
<p>Indices can be obtained using <a href="/docs/transformers/v4.26.0/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/v4.26.0/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> and
<a href="/docs/transformers/v4.26.0/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.TFGPTJForCausalLM.call.past_key_values",description:`<strong>past_key_values</strong> (<code>List[tf.Tensor]</code> of length <code>config.n_layers</code>) &#x2014;
Contains pre-computed hidden-states (key and values in the attention blocks) as computed by the model (see
<code>past</code> output below). Can be used to speed up sequential decoding. The token ids which have their past
given to this model should not be passed as input ids as they have already been computed.`,name:"past_key_values"},{anchor:"transformers.TFGPTJForCausalLM.call.attention_mask",description:`<strong>attention_mask</strong> (<code>tf.Tensor</code> or <code>Numpy array</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.TFGPTJForCausalLM.call.token_type_ids",description:`<strong>token_type_ids</strong> (<code>tf.Tensor</code> or <code>Numpy array</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.TFGPTJForCausalLM.call.position_ids",description:`<strong>position_ids</strong> (<code>tf.Tensor</code> or <code>Numpy array</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>.</p>
<p><a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.TFGPTJForCausalLM.call.head_mask",description:`<strong>head_mask</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.TFGPTJForCausalLM.call.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.TFGPTJForCausalLM.call.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail. This argument can be used only in eager mode, in graph mode the value in the
config will be used instead.`,name:"output_attentions"},{anchor:"transformers.TFGPTJForCausalLM.call.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail. This argument can be used only in eager mode, in graph mode the value in the config will be
used instead.`,name:"output_hidden_states"},{anchor:"transformers.TFGPTJForCausalLM.call.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/v4.26.0/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple. This argument can be used
in eager mode, in graph mode the value will always be set to True.`,name:"return_dict"},{anchor:"transformers.TFGPTJForCausalLM.call.training",description:`<strong>training</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to use the model in training mode (some modules like dropout modules have different
behaviors between training and evaluation).`,name:"training"},{anchor:"transformers.TFGPTJForCausalLM.call.labels",description:`<strong>labels</strong> (<code>np.ndarray</code> or <code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Labels for language modeling. Note that the labels <strong>are shifted</strong> inside the model, i.e. you can set
<code>labels = input_ids</code> Indices are selected in <code>[-100, 0, ..., config.vocab_size]</code> All labels set to <code>-100</code>
are ignored (masked), the loss is only computed for labels in <code>[0, ..., config.vocab_size]</code>`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/gptj/modeling_tf_gptj.py#L766",returnDescription:`
<p>A <a
  href="/docs/transformers/v4.26.0/en/main_classes/output#transformers.modeling_tf_outputs.TFCausalLMOutputWithPast"
>transformers.modeling_tf_outputs.TFCausalLMOutputWithPast</a> or a tuple of <code>tf.Tensor</code> (if
<code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various elements depending on the
configuration (<a
  href="/docs/transformers/v4.26.0/en/model_doc/gptj#transformers.GPTJConfig"
>GPTJConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>tf.Tensor</code> of shape <code>(n,)</code>, <em>optional</em>, where n is the number of non-masked labels, returned when <code>labels</code> is provided) \u2014 Language modeling loss (for next-token prediction).</p>
</li>
<li>
<p><strong>logits</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head (scores for each vocabulary token before SoftMax).</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>List[tf.Tensor]</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 List of <code>tf.Tensor</code> of length <code>config.n_layers</code>, with each tensor of shape <code>(2, batch_size, num_heads, sequence_length, embed_size_per_head)</code>).</p>
<p>Contains pre-computed hidden-states (key and values in the attention blocks) that can be used (see
<code>past_key_values</code> input) to speed up sequential decoding.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/v4.26.0/en/main_classes/output#transformers.modeling_tf_outputs.TFCausalLMOutputWithPast"
>transformers.modeling_tf_outputs.TFCausalLMOutputWithPast</a> or <code>tuple(tf.Tensor)</code></p>
`}}),No=new Oe({props:{$$slots:{default:[qm]},$$scope:{ctx:x}}}),Do=new ut({props:{anchor:"transformers.TFGPTJForCausalLM.call.example",$$slots:{default:[Cm]},$$scope:{ctx:x}}}),Vn=new ht({}),Xn=new _e({props:{name:"class transformers.TFGPTJForSequenceClassification",anchor:"transformers.TFGPTJForSequenceClassification",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TFGPTJForSequenceClassification.config",description:`<strong>config</strong> (<a href="/docs/transformers/v4.26.0/en/model_doc/gptj#transformers.GPTJConfig">GPTJConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/v4.26.0/en/main_classes/model#transformers.TFPreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/gptj/modeling_tf_gptj.py#L855"}}),Bo=new Oe({props:{$$slots:{default:[zm]},$$scope:{ctx:x}}}),ts=new _e({props:{name:"call",anchor:"transformers.TFGPTJForSequenceClassification.call",parameters:[{name:"input_ids",val:": typing.Union[typing.List[tensorflow.python.framework.ops.Tensor], typing.List[numpy.ndarray], typing.List[keras.engine.keras_tensor.KerasTensor], typing.Dict[str, tensorflow.python.framework.ops.Tensor], typing.Dict[str, numpy.ndarray], typing.Dict[str, keras.engine.keras_tensor.KerasTensor], tensorflow.python.framework.ops.Tensor, numpy.ndarray, keras.engine.keras_tensor.KerasTensor, NoneType] = None"},{name:"past_key_values",val:": typing.Union[typing.Tuple[typing.Tuple[typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor]]], NoneType] = None"},{name:"attention_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"token_type_ids",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"position_ids",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"head_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"inputs_embeds",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"labels",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"training",val:": typing.Optional[bool] = False"}],parametersDescription:[{anchor:"transformers.TFGPTJForSequenceClassification.call.input_ids",description:`<strong>input_ids</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, input_ids_length)</code>) &#x2014;
<code>input_ids_length</code> = <code>sequence_length</code> if <code>past</code> is <code>None</code> else <code>past[0].shape[-2]</code> (<code>sequence_length</code> of
input past key value states). Indices of input sequence tokens in the vocabulary.</p>
<p>If <code>past</code> is used, only input IDs that do not have their past calculated should be passed as <code>input_ids</code>.</p>
<p>Indices can be obtained using <a href="/docs/transformers/v4.26.0/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/v4.26.0/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> and
<a href="/docs/transformers/v4.26.0/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.TFGPTJForSequenceClassification.call.past_key_values",description:`<strong>past_key_values</strong> (<code>List[tf.Tensor]</code> of length <code>config.n_layers</code>) &#x2014;
Contains pre-computed hidden-states (key and values in the attention blocks) as computed by the model (see
<code>past</code> output below). Can be used to speed up sequential decoding. The token ids which have their past
given to this model should not be passed as input ids as they have already been computed.`,name:"past_key_values"},{anchor:"transformers.TFGPTJForSequenceClassification.call.attention_mask",description:`<strong>attention_mask</strong> (<code>tf.Tensor</code> or <code>Numpy array</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.TFGPTJForSequenceClassification.call.token_type_ids",description:`<strong>token_type_ids</strong> (<code>tf.Tensor</code> or <code>Numpy array</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.TFGPTJForSequenceClassification.call.position_ids",description:`<strong>position_ids</strong> (<code>tf.Tensor</code> or <code>Numpy array</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>.</p>
<p><a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.TFGPTJForSequenceClassification.call.head_mask",description:`<strong>head_mask</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.TFGPTJForSequenceClassification.call.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.TFGPTJForSequenceClassification.call.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail. This argument can be used only in eager mode, in graph mode the value in the
config will be used instead.`,name:"output_attentions"},{anchor:"transformers.TFGPTJForSequenceClassification.call.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail. This argument can be used only in eager mode, in graph mode the value in the config will be
used instead.`,name:"output_hidden_states"},{anchor:"transformers.TFGPTJForSequenceClassification.call.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/v4.26.0/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple. This argument can be used
in eager mode, in graph mode the value will always be set to True.`,name:"return_dict"},{anchor:"transformers.TFGPTJForSequenceClassification.call.training",description:`<strong>training</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to use the model in training mode (some modules like dropout modules have different
behaviors between training and evaluation).`,name:"training"},{anchor:"transformers.TFGPTJForSequenceClassification.call.labels",description:`<strong>labels</strong> (<code>np.ndarray</code> or <code>tf.Tensor</code> of shape <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for computing the sequence classification/regression loss. Indices should be in <code>[0, ..., config.num_labels - 1]</code>. If <code>config.num_labels == 1</code> a regression loss is computed (Mean-Square loss), If
<code>config.num_labels &gt; 1</code> a classification loss is computed (Cross-Entropy).`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/gptj/modeling_tf_gptj.py#L869",returnDescription:`
<p>A <a
  href="/docs/transformers/v4.26.0/en/model_doc/gpt2#transformers.modeling_tf_outputs.TFSequenceClassifierOutputWithPast"
>transformers.modeling_tf_outputs.TFSequenceClassifierOutputWithPast</a> or a tuple of <code>tf.Tensor</code> (if
<code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various elements depending on the
configuration (<a
  href="/docs/transformers/v4.26.0/en/model_doc/gptj#transformers.GPTJConfig"
>GPTJConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, )</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Classification (or regression if config.num_labels==1) loss.</p>
</li>
<li>
<p><strong>logits</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, config.num_labels)</code>) \u2014 Classification (or regression if config.num_labels==1) scores (before SoftMax).</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>List[tf.Tensor]</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 List of <code>tf.Tensor</code> of length <code>config.n_layers</code>, with each tensor of shape <code>(2, batch_size, num_heads, sequence_length, embed_size_per_head)</code>).</p>
<p>Contains pre-computed hidden-states (key and values in the attention blocks) that can be used (see
<code>past_key_values</code> input) to speed up sequential decoding.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/v4.26.0/en/model_doc/gpt2#transformers.modeling_tf_outputs.TFSequenceClassifierOutputWithPast"
>transformers.modeling_tf_outputs.TFSequenceClassifierOutputWithPast</a> or <code>tuple(tf.Tensor)</code></p>
`}}),Wo=new Oe({props:{$$slots:{default:[Am]},$$scope:{ctx:x}}}),Uo=new ut({props:{anchor:"transformers.TFGPTJForSequenceClassification.call.example",$$slots:{default:[Im]},$$scope:{ctx:x}}}),Qo=new ut({props:{anchor:"transformers.TFGPTJForSequenceClassification.call.example-2",$$slots:{default:[Lm]},$$scope:{ctx:x}}}),os=new ht({}),ns=new _e({props:{name:"class transformers.TFGPTJForQuestionAnswering",anchor:"transformers.TFGPTJForQuestionAnswering",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TFGPTJForQuestionAnswering.config",description:`<strong>config</strong> (<a href="/docs/transformers/v4.26.0/en/model_doc/gptj#transformers.GPTJConfig">GPTJConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/v4.26.0/en/main_classes/model#transformers.TFPreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/gptj/modeling_tf_gptj.py#L980"}}),Ko=new Oe({props:{$$slots:{default:[Om]},$$scope:{ctx:x}}}),is=new _e({props:{name:"call",anchor:"transformers.TFGPTJForQuestionAnswering.call",parameters:[{name:"input_ids",val:": typing.Union[typing.List[tensorflow.python.framework.ops.Tensor], typing.List[numpy.ndarray], typing.List[keras.engine.keras_tensor.KerasTensor], typing.Dict[str, tensorflow.python.framework.ops.Tensor], typing.Dict[str, numpy.ndarray], typing.Dict[str, keras.engine.keras_tensor.KerasTensor], tensorflow.python.framework.ops.Tensor, numpy.ndarray, keras.engine.keras_tensor.KerasTensor, NoneType] = None"},{name:"past_key_values",val:": typing.Union[typing.Tuple[typing.Tuple[typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor]]], NoneType] = None"},{name:"attention_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"token_type_ids",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"position_ids",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"head_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"inputs_embeds",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"start_positions",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"end_positions",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"training",val:": typing.Optional[bool] = False"}],parametersDescription:[{anchor:"transformers.TFGPTJForQuestionAnswering.call.input_ids",description:`<strong>input_ids</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, input_ids_length)</code>) &#x2014;
<code>input_ids_length</code> = <code>sequence_length</code> if <code>past</code> is <code>None</code> else <code>past[0].shape[-2]</code> (<code>sequence_length</code> of
input past key value states). Indices of input sequence tokens in the vocabulary.</p>
<p>If <code>past</code> is used, only input IDs that do not have their past calculated should be passed as <code>input_ids</code>.</p>
<p>Indices can be obtained using <a href="/docs/transformers/v4.26.0/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/v4.26.0/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> and
<a href="/docs/transformers/v4.26.0/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.TFGPTJForQuestionAnswering.call.past_key_values",description:`<strong>past_key_values</strong> (<code>List[tf.Tensor]</code> of length <code>config.n_layers</code>) &#x2014;
Contains pre-computed hidden-states (key and values in the attention blocks) as computed by the model (see
<code>past</code> output below). Can be used to speed up sequential decoding. The token ids which have their past
given to this model should not be passed as input ids as they have already been computed.`,name:"past_key_values"},{anchor:"transformers.TFGPTJForQuestionAnswering.call.attention_mask",description:`<strong>attention_mask</strong> (<code>tf.Tensor</code> or <code>Numpy array</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.TFGPTJForQuestionAnswering.call.token_type_ids",description:`<strong>token_type_ids</strong> (<code>tf.Tensor</code> or <code>Numpy array</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.TFGPTJForQuestionAnswering.call.position_ids",description:`<strong>position_ids</strong> (<code>tf.Tensor</code> or <code>Numpy array</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>.</p>
<p><a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.TFGPTJForQuestionAnswering.call.head_mask",description:`<strong>head_mask</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.TFGPTJForQuestionAnswering.call.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.TFGPTJForQuestionAnswering.call.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail. This argument can be used only in eager mode, in graph mode the value in the
config will be used instead.`,name:"output_attentions"},{anchor:"transformers.TFGPTJForQuestionAnswering.call.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail. This argument can be used only in eager mode, in graph mode the value in the config will be
used instead.`,name:"output_hidden_states"},{anchor:"transformers.TFGPTJForQuestionAnswering.call.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/v4.26.0/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple. This argument can be used
in eager mode, in graph mode the value will always be set to True.`,name:"return_dict"},{anchor:"transformers.TFGPTJForQuestionAnswering.call.training",description:`<strong>training</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to use the model in training mode (some modules like dropout modules have different
behaviors between training and evaluation).`,name:"training"},{anchor:"transformers.TFGPTJForQuestionAnswering.call.start_positions",description:`<strong>start_positions</strong> (<code>np.ndarray</code> or <code>tf.Tensor</code> of shape <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for position (index) of the start of the labelled span for computing the token classification loss.
Positions are clamped to the length of the sequence (<code>sequence_length</code>). Position outside of the sequence
are not taken into account for computing the loss.`,name:"start_positions"},{anchor:"transformers.TFGPTJForQuestionAnswering.call.end_positions",description:`<strong>end_positions</strong> (<code>np.ndarray</code> or <code>tf.Tensor</code> of shape <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for position (index) of the end of the labelled span for computing the token classification loss.
Positions are clamped to the length of the sequence (<code>sequence_length</code>). Position outside of the sequence
are not taken into account for computing the loss.`,name:"end_positions"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/gptj/modeling_tf_gptj.py#L991",returnDescription:`
<p>A <a
  href="/docs/transformers/v4.26.0/en/main_classes/output#transformers.modeling_tf_outputs.TFQuestionAnsweringModelOutput"
>transformers.modeling_tf_outputs.TFQuestionAnsweringModelOutput</a> or a tuple of <code>tf.Tensor</code> (if
<code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various elements depending on the
configuration (<a
  href="/docs/transformers/v4.26.0/en/model_doc/gptj#transformers.GPTJConfig"
>GPTJConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, )</code>, <em>optional</em>, returned when <code>start_positions</code> and <code>end_positions</code> are provided) \u2014 Total span extraction loss is the sum of a Cross-Entropy for the start and end positions.</p>
</li>
<li>
<p><strong>start_logits</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>) \u2014 Span-start scores (before SoftMax).</p>
</li>
<li>
<p><strong>end_logits</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>) \u2014 Span-end scores (before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/v4.26.0/en/main_classes/output#transformers.modeling_tf_outputs.TFQuestionAnsweringModelOutput"
>transformers.modeling_tf_outputs.TFQuestionAnsweringModelOutput</a> or <code>tuple(tf.Tensor)</code></p>
`}}),Ro=new Oe({props:{$$slots:{default:[Nm]},$$scope:{ctx:x}}}),Vo=new ut({props:{anchor:"transformers.TFGPTJForQuestionAnswering.call.example",$$slots:{default:[Dm]},$$scope:{ctx:x}}}),Xo=new ut({props:{anchor:"transformers.TFGPTJForQuestionAnswering.call.example-2",$$slots:{default:[Sm]},$$scope:{ctx:x}}}),ls=new ht({}),ds=new _e({props:{name:"class transformers.FlaxGPTJModel",anchor:"transformers.FlaxGPTJModel",parameters:[{name:"config",val:": GPTJConfig"},{name:"input_shape",val:": typing.Tuple = (1, 1)"},{name:"seed",val:": int = 0"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"},{name:"_do_init",val:": bool = True"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.FlaxGPTJModel.config",description:`<strong>config</strong> (<a href="/docs/transformers/v4.26.0/en/model_doc/gptj#transformers.GPTJConfig">GPTJConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/v4.26.0/en/main_classes/model#transformers.FlaxPreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"},{anchor:"transformers.FlaxGPTJModel.dtype",description:`<strong>dtype</strong> (<code>jax.numpy.dtype</code>, <em>optional</em>, defaults to <code>jax.numpy.float32</code>) &#x2014;
The data type of the computation. Can be one of <code>jax.numpy.float32</code>, <code>jax.numpy.float16</code> (on GPUs) and
<code>jax.numpy.bfloat16</code> (on TPUs).</p>
<p>This can be used to enable mixed-precision training or half-precision inference on GPUs or TPUs. If
specified all the computation will be performed with the given <code>dtype</code>.</p>
<p><strong>Note that this only specifies the dtype of the computation and does not influence the dtype of model
parameters.</strong></p>
<p>If you wish to change the dtype of the model parameters, see <a href="/docs/transformers/v4.26.0/en/main_classes/model#transformers.FlaxPreTrainedModel.to_fp16">to_fp16()</a> and
<a href="/docs/transformers/v4.26.0/en/main_classes/model#transformers.FlaxPreTrainedModel.to_bf16">to_bf16()</a>.`,name:"dtype"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/gptj/modeling_flax_gptj.py#L618"}}),_s=new _e({props:{name:"__call__",anchor:"transformers.FlaxGPTJModel.__call__",parameters:[{name:"input_ids",val:""},{name:"attention_mask",val:" = None"},{name:"position_ids",val:" = None"},{name:"params",val:": dict = None"},{name:"past_key_values",val:": dict = None"},{name:"dropout_rng",val:": PRNGKey = None"},{name:"train",val:": bool = False"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.FlaxGPTJModel.__call__.input_ids",description:`<strong>input_ids</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, input_ids_length)</code>) &#x2014;
<code>input_ids_length</code> = <code>sequence_length</code>. Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/v4.26.0/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/v4.26.0/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/v4.26.0/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.FlaxGPTJModel.__call__.attention_mask",description:`<strong>attention_mask</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.FlaxGPTJModel.__call__.position_ids",description:`<strong>position_ids</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>.`,name:"position_ids"},{anchor:"transformers.FlaxGPTJModel.__call__.past_key_values",description:`<strong>past_key_values</strong> (<code>Dict[str, np.ndarray]</code>, <em>optional</em>, returned by <code>init_cache</code> or when passing previous <code>past_key_values</code>) &#x2014;
Dictionary of pre-computed hidden-states (key and values in the attention blocks) that can be used for fast
auto-regressive decoding. Pre-computed key and value hidden-states are of shape <em>[batch_size, max_length]</em>.`,name:"past_key_values"},{anchor:"transformers.FlaxGPTJModel.__call__.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.FlaxGPTJModel.__call__.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.FlaxGPTJModel.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/v4.26.0/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/gptj/modeling_flax_gptj.py#L436",returnDescription:`
<p>A <a
  href="/docs/transformers/v4.26.0/en/main_classes/output#transformers.modeling_flax_outputs.FlaxMaskedLMOutput"
>transformers.modeling_flax_outputs.FlaxMaskedLMOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/v4.26.0/en/model_doc/gptj#transformers.GPTJConfig"
>GPTJConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>logits</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head (scores for each vocabulary token before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/v4.26.0/en/main_classes/output#transformers.modeling_flax_outputs.FlaxMaskedLMOutput"
>transformers.modeling_flax_outputs.FlaxMaskedLMOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),Zo=new Oe({props:{$$slots:{default:[Bm]},$$scope:{ctx:x}}}),en=new ut({props:{anchor:"transformers.FlaxGPTJModel.__call__.example",$$slots:{default:[Wm]},$$scope:{ctx:x}}}),Ts=new ht({}),ys=new _e({props:{name:"class transformers.FlaxGPTJForCausalLM",anchor:"transformers.FlaxGPTJForCausalLM",parameters:[{name:"config",val:": GPTJConfig"},{name:"input_shape",val:": typing.Tuple = (1, 1)"},{name:"seed",val:": int = 0"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"},{name:"_do_init",val:": bool = True"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.FlaxGPTJForCausalLM.config",description:`<strong>config</strong> (<a href="/docs/transformers/v4.26.0/en/model_doc/gptj#transformers.GPTJConfig">GPTJConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/v4.26.0/en/main_classes/model#transformers.FlaxPreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"},{anchor:"transformers.FlaxGPTJForCausalLM.dtype",description:`<strong>dtype</strong> (<code>jax.numpy.dtype</code>, <em>optional</em>, defaults to <code>jax.numpy.float32</code>) &#x2014;
The data type of the computation. Can be one of <code>jax.numpy.float32</code>, <code>jax.numpy.float16</code> (on GPUs) and
<code>jax.numpy.bfloat16</code> (on TPUs).</p>
<p>This can be used to enable mixed-precision training or half-precision inference on GPUs or TPUs. If
specified all the computation will be performed with the given <code>dtype</code>.</p>
<p><strong>Note that this only specifies the dtype of the computation and does not influence the dtype of model
parameters.</strong></p>
<p>If you wish to change the dtype of the model parameters, see <a href="/docs/transformers/v4.26.0/en/main_classes/model#transformers.FlaxPreTrainedModel.to_fp16">to_fp16()</a> and
<a href="/docs/transformers/v4.26.0/en/main_classes/model#transformers.FlaxPreTrainedModel.to_bf16">to_bf16()</a>.`,name:"dtype"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/gptj/modeling_flax_gptj.py#L684"}}),js=new _e({props:{name:"__call__",anchor:"transformers.FlaxGPTJForCausalLM.__call__",parameters:[{name:"input_ids",val:""},{name:"attention_mask",val:" = None"},{name:"position_ids",val:" = None"},{name:"params",val:": dict = None"},{name:"past_key_values",val:": dict = None"},{name:"dropout_rng",val:": PRNGKey = None"},{name:"train",val:": bool = False"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.FlaxGPTJForCausalLM.__call__.input_ids",description:`<strong>input_ids</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, input_ids_length)</code>) &#x2014;
<code>input_ids_length</code> = <code>sequence_length</code>. Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/v4.26.0/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/v4.26.0/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/v4.26.0/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.FlaxGPTJForCausalLM.__call__.attention_mask",description:`<strong>attention_mask</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.FlaxGPTJForCausalLM.__call__.position_ids",description:`<strong>position_ids</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>.`,name:"position_ids"},{anchor:"transformers.FlaxGPTJForCausalLM.__call__.past_key_values",description:`<strong>past_key_values</strong> (<code>Dict[str, np.ndarray]</code>, <em>optional</em>, returned by <code>init_cache</code> or when passing previous <code>past_key_values</code>) &#x2014;
Dictionary of pre-computed hidden-states (key and values in the attention blocks) that can be used for fast
auto-regressive decoding. Pre-computed key and value hidden-states are of shape <em>[batch_size, max_length]</em>.`,name:"past_key_values"},{anchor:"transformers.FlaxGPTJForCausalLM.__call__.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.FlaxGPTJForCausalLM.__call__.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.FlaxGPTJForCausalLM.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/v4.26.0/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/gptj/modeling_flax_gptj.py#L436",returnDescription:`
<p>A <a
  href="/docs/transformers/v4.26.0/en/main_classes/output#transformers.modeling_flax_outputs.FlaxMaskedLMOutput"
>transformers.modeling_flax_outputs.FlaxMaskedLMOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/v4.26.0/en/model_doc/gptj#transformers.GPTJConfig"
>GPTJConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>logits</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head (scores for each vocabulary token before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/v4.26.0/en/main_classes/output#transformers.modeling_flax_outputs.FlaxMaskedLMOutput"
>transformers.modeling_flax_outputs.FlaxMaskedLMOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),on=new Oe({props:{$$slots:{default:[Um]},$$scope:{ctx:x}}}),nn=new ut({props:{anchor:"transformers.FlaxGPTJForCausalLM.__call__.example",$$slots:{default:[Qm]},$$scope:{ctx:x}}}),{c(){d=a("meta"),y=h(),p=a("h1"),f=a("a"),T=a("span"),w(l.$$.fragment),c=h(),j=a("span"),z=n("GPT-J"),J=h(),C=a("h2"),D=a("a"),oe=a("span"),w(E.$$.fragment),be=h(),H=a("span"),$e=n("Overview"),Te=h(),B=a("p"),Pe=n("The GPT-J model was released in the "),re=a("a"),V=n("kingoflolz/mesh-transformer-jax"),Fe=n(` repository by Ben Wang and Aran Komatsuzaki. It is a GPT-2-like
causal language model trained on `),ie=a("a"),X=n("the Pile"),je=n(" dataset."),ye=h(),Q=a("p"),Ee=n("This model was contributed by "),le=a("a"),de=n("Stella Biderman"),q=n("."),A=h(),ue=a("p"),Y=n("Tips:"),ve=h(),fe=a("ul"),O=a("li"),xe=n("To load "),ce=a("a"),L=n("GPT-J"),Ge=n(` in float32 one would need at least 2x model size CPU
RAM: 1x for initial weights and another 1x to load the checkpoint. So for GPT-J it would take at least 48GB of CPU
RAM to just load the model. To reduce the CPU RAM usage there are a few options. The `),K=a("code"),Me=n("torch_dtype"),Je=n(` argument can be
used to initialize the model in half-precision. And the `),R=a("code"),qe=n("low_cpu_mem_usage"),Ce=n(` argument can be used to keep the RAM
usage to 1x. There is also a `),S=a("a"),ze=n("fp16 branch"),Z=n(` which stores
the fp16 weights, which could be used to further minimize the RAM usage. Combining all this it should take roughly
12.1GB of CPU RAM to load the model.`),we=h(),w(ee.$$.fragment),I=h(),ae=a("ul"),N=a("li"),me=a("p"),Ae=n(`The model should fit on 16GB GPU for inference. For training/fine-tuning it would take much more GPU RAM. Adam
optimizer for example makes four copies of the model: model, gradients, average and squared average of the gradients.
So it would need at least 4x model size GPU memory, even with mixed precision as gradient updates are in fp32. This
is not including the activations and data batches, which would again require some more GPU RAM. So one should explore
solutions such as DeepSpeed, to train/fine-tune the model. Another option is to use the original codebase to
train/fine-tune the model on TPU and then convert the model to Transformers format for inference. Instructions for
that could be found `),v=a("a"),G=n("here"),Ve=h(),ne=a("li"),pe=a("p"),Xe=n(`Although the embedding matrix has a size of 50400, only 50257 entries are used by the GPT-2 tokenizer. These extra
tokens are added for the sake of efficiency on TPUs. To avoid the mismatch between embedding matrix size and vocab
size, the tokenizer for `),M=a("a"),Ye=n("GPT-J"),Ze=n(` contains 143 extra tokens
`),Ne=a("code"),et=n("<|extratoken_1|>... <|extratoken_143|>"),tt=n(", so the "),W=a("code"),te=n("vocab_size"),ot=n(" of tokenizer also becomes 50400."),He=h(),U=a("h3"),ke=a("a"),De=a("span"),w(he.$$.fragment),nt=h(),se=a("span"),st=n("Generation"),Rr=h(),fo=a("p"),Vi=n("The "),qs=a("a"),Xi=n("generate()"),Yi=n(` method can be used to generate text using GPT-J
model.`),Vr=h(),w(un.$$.fragment),Xr=h(),Cs=a("p"),Zi=n("\u2026or in float16 precision:"),Yr=h(),w(fn.$$.fragment),Zr=h(),Bt=a("h2"),mo=a("a"),_a=a("span"),w(mn.$$.fragment),el=h(),Ta=a("span"),tl=n("GPTJConfig"),ei=h(),Gt=a("div"),w(gn.$$.fragment),ol=h(),mt=a("p"),nl=n("This is the configuration class to store the configuration of a "),zs=a("a"),sl=n("GPTJModel"),al=n(`. It is used to instantiate a GPT-J
model according to the specified arguments, defining the model architecture. Instantiating a configuration with the
defaults will yield a similar configuration to that of the GPT-J
`),_n=a("a"),rl=n("EleutherAI/gpt-j-6B"),il=n(` architecture. Configuration objects inherit from
`),As=a("a"),ll=n("PretrainedConfig"),dl=n(" and can be used to control the model outputs. Read the documentation from "),Is=a("a"),cl=n("PretrainedConfig"),pl=n(`
for more information.`),hl=h(),w(go.$$.fragment),ti=h(),Wt=a("h2"),_o=a("a"),ya=a("span"),w(Tn.$$.fragment),ul=h(),va=a("span"),fl=n("GPTJModel"),oi=h(),Mt=a("div"),w(yn.$$.fragment),ml=h(),vn=a("p"),gl=n(`The bare GPT-J Model transformer outputting raw hidden-states without any specific head on top.
This model is a PyTorch `),wn=a("a"),_l=n("torch.nn.Module"),Tl=n(` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),yl=h(),at=a("div"),w(kn.$$.fragment),vl=h(),Ut=a("p"),wl=n("The "),Ls=a("a"),kl=n("GPTJModel"),bl=n(" forward method, overrides the "),wa=a("code"),$l=n("__call__"),Pl=n(" special method."),Fl=h(),w(To.$$.fragment),jl=h(),w(yo.$$.fragment),El=h(),w(vo.$$.fragment),ni=h(),Qt=a("h2"),wo=a("a"),ka=a("span"),w(bn.$$.fragment),xl=h(),ba=a("span"),Gl=n("GPTJForCausalLM"),si=h(),gt=a("div"),w($n.$$.fragment),Ml=h(),$a=a("p"),Jl=n("The GPT-J Model transformer with a language modeling head on top."),ql=h(),Pn=a("p"),Cl=n("This model is a PyTorch "),Fn=a("a"),zl=n("torch.nn.Module"),Al=n(` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Il=h(),rt=a("div"),w(jn.$$.fragment),Ll=h(),Ht=a("p"),Ol=n("The "),Os=a("a"),Nl=n("GPTJForCausalLM"),Dl=n(" forward method, overrides the "),Pa=a("code"),Sl=n("__call__"),Bl=n(" special method."),Wl=h(),w(ko.$$.fragment),Ul=h(),w(bo.$$.fragment),Ql=h(),w($o.$$.fragment),ai=h(),Kt=a("h2"),Po=a("a"),Fa=a("span"),w(En.$$.fragment),Hl=h(),ja=a("span"),Kl=n("GPTJForSequenceClassification"),ri=h(),Se=a("div"),w(xn.$$.fragment),Rl=h(),Ea=a("p"),Vl=n("The GPT-J Model transformer with a sequence classification head on top (linear layer)."),Xl=h(),Ns=a("p"),Ds=a("a"),Yl=n("GPTJForSequenceClassification"),Zl=n(` uses the last token in order to do the classification, as other causal models
(e.g. GPT, GPT-2, GPT-Neo) do.`),ed=h(),_t=a("p"),td=n(`Since it does classification on the last token, it requires to know the position of the last token. If a
`),xa=a("code"),od=n("pad_token_id"),nd=n(` is defined in the configuration, it finds the last token that is not a padding token in each row. If
no `),Ga=a("code"),sd=n("pad_token_id"),ad=n(` is defined, it simply takes the last value in each row of the batch. Since it cannot guess the
padding tokens when `),Ma=a("code"),rd=n("inputs_embeds"),id=n(" are passed instead of "),Ja=a("code"),ld=n("input_ids"),dd=n(`, it does the same (take the last value in
each row of the batch).`),cd=h(),Gn=a("p"),pd=n("This model is a PyTorch "),Mn=a("a"),hd=n("torch.nn.Module"),ud=n(` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),fd=h(),Ke=a("div"),w(Jn.$$.fragment),md=h(),Rt=a("p"),gd=n("The "),Ss=a("a"),_d=n("GPTJForSequenceClassification"),Td=n(" forward method, overrides the "),qa=a("code"),yd=n("__call__"),vd=n(" special method."),wd=h(),w(Fo.$$.fragment),kd=h(),w(jo.$$.fragment),bd=h(),w(Eo.$$.fragment),$d=h(),w(xo.$$.fragment),ii=h(),Vt=a("h2"),Go=a("a"),Ca=a("span"),w(qn.$$.fragment),Pd=h(),za=a("span"),Fd=n("GPTJForQuestionAnswering"),li=h(),Tt=a("div"),w(Cn.$$.fragment),jd=h(),Xt=a("p"),Ed=n(`The GPT-J Model transformer with a span classification head on top for extractive question-answering tasks like
SQuAD (a linear layers on top of the hidden-states output to compute `),Aa=a("code"),xd=n("span start logits"),Gd=n(" and "),Ia=a("code"),Md=n("span end logits"),Jd=n(")."),qd=h(),zn=a("p"),Cd=n("This model is a PyTorch "),An=a("a"),zd=n("torch.nn.Module"),Ad=n(` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Id=h(),it=a("div"),w(In.$$.fragment),Ld=h(),Yt=a("p"),Od=n("The "),Bs=a("a"),Nd=n("GPTJForQuestionAnswering"),Dd=n(" forward method, overrides the "),La=a("code"),Sd=n("__call__"),Bd=n(" special method."),Wd=h(),w(Mo.$$.fragment),Ud=h(),w(Jo.$$.fragment),Qd=h(),w(qo.$$.fragment),di=h(),Zt=a("h2"),Co=a("a"),Oa=a("span"),w(Ln.$$.fragment),Hd=h(),Na=a("span"),Kd=n("TFGPTJModel"),ci=h(),Be=a("div"),w(On.$$.fragment),Rd=h(),Da=a("p"),Vd=n("The bare GPT-J Model transformer outputting raw hidden-states without any specific head on top."),Xd=h(),Nn=a("p"),Yd=n("This model inherits from "),Ws=a("a"),Zd=n("TFPreTrainedModel"),ec=n(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),tc=h(),Dn=a("p"),oc=n("This model is also a "),Sn=a("a"),nc=n("tf.keras.Model"),sc=n(` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),ac=h(),w(zo.$$.fragment),rc=h(),wt=a("div"),w(Bn.$$.fragment),ic=h(),eo=a("p"),lc=n("The "),Us=a("a"),dc=n("TFGPTJModel"),cc=n(" forward method, overrides the "),Sa=a("code"),pc=n("__call__"),hc=n(" special method."),uc=h(),w(Ao.$$.fragment),fc=h(),w(Io.$$.fragment),pi=h(),to=a("h2"),Lo=a("a"),Ba=a("span"),w(Wn.$$.fragment),mc=h(),Wa=a("span"),gc=n("TFGPTJForCausalLM"),hi=h(),We=a("div"),w(Un.$$.fragment),_c=h(),Ua=a("p"),Tc=n("The GPT-J Model transformer with a language modeling head on top."),yc=h(),Qn=a("p"),vc=n("This model inherits from "),Qs=a("a"),wc=n("TFPreTrainedModel"),kc=n(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),bc=h(),Hn=a("p"),$c=n("This model is also a "),Kn=a("a"),Pc=n("tf.keras.Model"),Fc=n(` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),jc=h(),w(Oo.$$.fragment),Ec=h(),kt=a("div"),w(Rn.$$.fragment),xc=h(),oo=a("p"),Gc=n("The "),Hs=a("a"),Mc=n("TFGPTJForCausalLM"),Jc=n(" forward method, overrides the "),Qa=a("code"),qc=n("__call__"),Cc=n(" special method."),zc=h(),w(No.$$.fragment),Ac=h(),w(Do.$$.fragment),ui=h(),no=a("h2"),So=a("a"),Ha=a("span"),w(Vn.$$.fragment),Ic=h(),Ka=a("span"),Lc=n("TFGPTJForSequenceClassification"),fi=h(),ge=a("div"),w(Xn.$$.fragment),Oc=h(),Ra=a("p"),Nc=n("The GPT-J Model transformer with a sequence classification head on top (linear layer)."),Dc=h(),Ks=a("p"),Rs=a("a"),Sc=n("GPTJForSequenceClassification"),Bc=n(` uses the last token in order to do the classification, as other causal models
(e.g. GPT, GPT-2, GPT-Neo) do.`),Wc=h(),yt=a("p"),Uc=n(`Since it does classification on the last token, it requires to know the position of the last token. If a
`),Va=a("code"),Qc=n("pad_token_id"),Hc=n(` is defined in the configuration, it finds the last token that is not a padding token in each row. If
no `),Xa=a("code"),Kc=n("pad_token_id"),Rc=n(` is defined, it simply takes the last value in each row of the batch. Since it cannot guess the
padding tokens when `),Ya=a("code"),Vc=n("inputs_embeds"),Xc=n(" are passed instead of "),Za=a("code"),Yc=n("input_ids"),Zc=n(`, it does the same (take the last value in
each row of the batch).`),ep=h(),Yn=a("p"),tp=n("This model inherits from "),Vs=a("a"),op=n("TFPreTrainedModel"),np=n(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),sp=h(),Zn=a("p"),ap=n("This model is also a "),es=a("a"),rp=n("tf.keras.Model"),ip=n(` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),lp=h(),w(Bo.$$.fragment),dp=h(),lt=a("div"),w(ts.$$.fragment),cp=h(),so=a("p"),pp=n("The "),Xs=a("a"),hp=n("TFGPTJForSequenceClassification"),up=n(" forward method, overrides the "),er=a("code"),fp=n("__call__"),mp=n(" special method."),gp=h(),w(Wo.$$.fragment),_p=h(),w(Uo.$$.fragment),Tp=h(),w(Qo.$$.fragment),mi=h(),ao=a("h2"),Ho=a("a"),tr=a("span"),w(os.$$.fragment),yp=h(),or=a("span"),vp=n("TFGPTJForQuestionAnswering"),gi=h(),Ue=a("div"),w(ns.$$.fragment),wp=h(),ro=a("p"),kp=n(`The GPT-J Model transformer with a span classification head on top for extractive question-answering tasks like
SQuAD (a linear layers on top of the hidden-states output to compute `),nr=a("code"),bp=n("span start logits"),$p=n(" and "),sr=a("code"),Pp=n("span end logits"),Fp=n(")."),jp=h(),ss=a("p"),Ep=n("This model inherits from "),Ys=a("a"),xp=n("TFPreTrainedModel"),Gp=n(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Mp=h(),as=a("p"),Jp=n("This model is also a "),rs=a("a"),qp=n("tf.keras.Model"),Cp=n(` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),zp=h(),w(Ko.$$.fragment),Ap=h(),dt=a("div"),w(is.$$.fragment),Ip=h(),io=a("p"),Lp=n("The "),Zs=a("a"),Op=n("TFGPTJForQuestionAnswering"),Np=n(" forward method, overrides the "),ar=a("code"),Dp=n("__call__"),Sp=n(" special method."),Bp=h(),w(Ro.$$.fragment),Wp=h(),w(Vo.$$.fragment),Up=h(),w(Xo.$$.fragment),_i=h(),lo=a("h2"),Yo=a("a"),rr=a("span"),w(ls.$$.fragment),Qp=h(),ir=a("span"),Hp=n("FlaxGPTJModel"),Ti=h(),Ie=a("div"),w(ds.$$.fragment),Kp=h(),lr=a("p"),Rp=n("The bare GPTJ Model transformer outputting raw hidden-states without any specific head on top."),Vp=h(),cs=a("p"),Xp=n("This model inherits from "),ea=a("a"),Yp=n("FlaxPreTrainedModel"),Zp=n(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),eh=h(),ps=a("p"),th=n(`This model is also a Flax Linen
`),hs=a("a"),oh=n("flax.nn.Module"),nh=n(` subclass. Use it as a
regular Flax Module and refer to the Flax documentation for all matter related to general usage and behavior.`),sh=h(),dr=a("p"),ah=n("Finally, this model supports inherent JAX features such as:"),rh=h(),Jt=a("ul"),cr=a("li"),us=a("a"),ih=n("Just-In-Time (JIT) compilation"),lh=h(),pr=a("li"),fs=a("a"),dh=n("Automatic Differentiation"),ch=h(),hr=a("li"),ms=a("a"),ph=n("Vectorization"),hh=h(),ur=a("li"),gs=a("a"),uh=n("Parallelization"),fh=h(),bt=a("div"),w(_s.$$.fragment),mh=h(),co=a("p"),gh=n("The "),fr=a("code"),_h=n("FlaxGPTJPreTrainedModel"),Th=n(" forward method, overrides the "),mr=a("code"),yh=n("__call__"),vh=n(" special method."),wh=h(),w(Zo.$$.fragment),kh=h(),w(en.$$.fragment),yi=h(),po=a("h2"),tn=a("a"),gr=a("span"),w(Ts.$$.fragment),bh=h(),_r=a("span"),$h=n("FlaxGPTJForCausalLM"),vi=h(),Le=a("div"),w(ys.$$.fragment),Ph=h(),Tr=a("p"),Fh=n("The GPTJ Model transformer with a language modeling head on top."),jh=h(),vs=a("p"),Eh=n("This model inherits from "),ta=a("a"),xh=n("FlaxPreTrainedModel"),Gh=n(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Mh=h(),ws=a("p"),Jh=n(`This model is also a Flax Linen
`),ks=a("a"),qh=n("flax.nn.Module"),Ch=n(` subclass. Use it as a
regular Flax Module and refer to the Flax documentation for all matter related to general usage and behavior.`),zh=h(),yr=a("p"),Ah=n("Finally, this model supports inherent JAX features such as:"),Ih=h(),qt=a("ul"),vr=a("li"),bs=a("a"),Lh=n("Just-In-Time (JIT) compilation"),Oh=h(),wr=a("li"),$s=a("a"),Nh=n("Automatic Differentiation"),Dh=h(),kr=a("li"),Ps=a("a"),Sh=n("Vectorization"),Bh=h(),br=a("li"),Fs=a("a"),Wh=n("Parallelization"),Uh=h(),$t=a("div"),w(js.$$.fragment),Qh=h(),ho=a("p"),Hh=n("The "),$r=a("code"),Kh=n("FlaxGPTJPreTrainedModel"),Rh=n(" forward method, overrides the "),Pr=a("code"),Vh=n("__call__"),Xh=n(" special method."),Yh=h(),w(on.$$.fragment),Zh=h(),w(nn.$$.fragment),this.h()},l(o){const _=um('[data-svelte="svelte-1phssyn"]',document.head);d=r(_,"META",{name:!0,content:!0}),_.forEach(t),y=u(o),p=r(o,"H1",{class:!0});var Es=i(p);f=r(Es,"A",{id:!0,class:!0,href:!0});var Fr=i(f);T=r(Fr,"SPAN",{});var jr=i(T);k(l.$$.fragment,jr),jr.forEach(t),Fr.forEach(t),c=u(Es),j=r(Es,"SPAN",{});var Er=i(j);z=s(Er,"GPT-J"),Er.forEach(t),Es.forEach(t),J=u(o),C=r(o,"H2",{class:!0});var xs=i(C);D=r(xs,"A",{id:!0,class:!0,href:!0});var xr=i(D);oe=r(xr,"SPAN",{});var Gr=i(oe);k(E.$$.fragment,Gr),Gr.forEach(t),xr.forEach(t),be=u(xs),H=r(xs,"SPAN",{});var Mr=i(H);$e=s(Mr,"Overview"),Mr.forEach(t),xs.forEach(t),Te=u(o),B=r(o,"P",{});var uo=i(B);Pe=s(uo,"The GPT-J model was released in the "),re=r(uo,"A",{href:!0,rel:!0});var Jr=i(re);V=s(Jr,"kingoflolz/mesh-transformer-jax"),Jr.forEach(t),Fe=s(uo,` repository by Ben Wang and Aran Komatsuzaki. It is a GPT-2-like
causal language model trained on `),ie=r(uo,"A",{href:!0,rel:!0});var qr=i(ie);X=s(qr,"the Pile"),qr.forEach(t),je=s(uo," dataset."),uo.forEach(t),ye=u(o),Q=r(o,"P",{});var Gs=i(Q);Ee=s(Gs,"This model was contributed by "),le=r(Gs,"A",{href:!0,rel:!0});var Cr=i(le);de=s(Cr,"Stella Biderman"),Cr.forEach(t),q=s(Gs,"."),Gs.forEach(t),A=u(o),ue=r(o,"P",{});var zr=i(ue);Y=s(zr,"Tips:"),zr.forEach(t),ve=u(o),fe=r(o,"UL",{});var Ar=i(fe);O=r(Ar,"LI",{});var vt=i(O);xe=s(vt,"To load "),ce=r(vt,"A",{href:!0,rel:!0});var Ir=i(ce);L=s(Ir,"GPT-J"),Ir.forEach(t),Ge=s(vt,` in float32 one would need at least 2x model size CPU
RAM: 1x for initial weights and another 1x to load the checkpoint. So for GPT-J it would take at least 48GB of CPU
RAM to just load the model. To reduce the CPU RAM usage there are a few options. The `),K=r(vt,"CODE",{});var Lr=i(K);Me=s(Lr,"torch_dtype"),Lr.forEach(t),Je=s(vt,` argument can be
used to initialize the model in half-precision. And the `),R=r(vt,"CODE",{});var Or=i(R);qe=s(Or,"low_cpu_mem_usage"),Or.forEach(t),Ce=s(vt,` argument can be used to keep the RAM
usage to 1x. There is also a `),S=r(vt,"A",{href:!0,rel:!0});var Nr=i(S);ze=s(Nr,"fp16 branch"),Nr.forEach(t),Z=s(vt,` which stores
the fp16 weights, which could be used to further minimize the RAM usage. Combining all this it should take roughly
12.1GB of CPU RAM to load the model.`),vt.forEach(t),Ar.forEach(t),we=u(o),k(ee.$$.fragment,o),I=u(o),ae=r(o,"UL",{});var Ms=i(ae);N=r(Ms,"LI",{});var Dr=i(N);me=r(Dr,"P",{});var oa=i(me);Ae=s(oa,`The model should fit on 16GB GPU for inference. For training/fine-tuning it would take much more GPU RAM. Adam
optimizer for example makes four copies of the model: model, gradients, average and squared average of the gradients.
So it would need at least 4x model size GPU memory, even with mixed precision as gradient updates are in fp32. This
is not including the activations and data batches, which would again require some more GPU RAM. So one should explore
solutions such as DeepSpeed, to train/fine-tune the model. Another option is to use the original codebase to
train/fine-tune the model on TPU and then convert the model to Transformers format for inference. Instructions for
that could be found `),v=r(oa,"A",{href:!0,rel:!0});var Sr=i(v);G=s(Sr,"here"),Sr.forEach(t),oa.forEach(t),Dr.forEach(t),Ve=u(Ms),ne=r(Ms,"LI",{});var Br=i(ne);pe=r(Br,"P",{});var Ct=i(pe);Xe=s(Ct,`Although the embedding matrix has a size of 50400, only 50257 entries are used by the GPT-2 tokenizer. These extra
tokens are added for the sake of efficiency on TPUs. To avoid the mismatch between embedding matrix size and vocab
size, the tokenizer for `),M=r(Ct,"A",{href:!0,rel:!0});var Wr=i(M);Ye=s(Wr,"GPT-J"),Wr.forEach(t),Ze=s(Ct,` contains 143 extra tokens
`),Ne=r(Ct,"CODE",{});var Ur=i(Ne);et=s(Ur,"<|extratoken_1|>... <|extratoken_143|>"),Ur.forEach(t),tt=s(Ct,", so the "),W=r(Ct,"CODE",{});var Qr=i(W);te=s(Qr,"vocab_size"),Qr.forEach(t),ot=s(Ct," of tokenizer also becomes 50400."),Ct.forEach(t),Br.forEach(t),Ms.forEach(t),He=u(o),U=r(o,"H3",{class:!0});var Js=i(U);ke=r(Js,"A",{id:!0,class:!0,href:!0});var Hr=i(ke);De=r(Hr,"SPAN",{});var Kr=i(De);k(he.$$.fragment,Kr),Kr.forEach(t),Hr.forEach(t),nt=u(Js),se=r(Js,"SPAN",{});var ou=i(se);st=s(ou,"Generation"),ou.forEach(t),Js.forEach(t),Rr=u(o),fo=r(o,"P",{});var ki=i(fo);Vi=s(ki,"The "),qs=r(ki,"A",{href:!0});var nu=i(qs);Xi=s(nu,"generate()"),nu.forEach(t),Yi=s(ki,` method can be used to generate text using GPT-J
model.`),ki.forEach(t),Vr=u(o),k(un.$$.fragment,o),Xr=u(o),Cs=r(o,"P",{});var su=i(Cs);Zi=s(su,"\u2026or in float16 precision:"),su.forEach(t),Yr=u(o),k(fn.$$.fragment,o),Zr=u(o),Bt=r(o,"H2",{class:!0});var bi=i(Bt);mo=r(bi,"A",{id:!0,class:!0,href:!0});var au=i(mo);_a=r(au,"SPAN",{});var ru=i(_a);k(mn.$$.fragment,ru),ru.forEach(t),au.forEach(t),el=u(bi),Ta=r(bi,"SPAN",{});var iu=i(Ta);tl=s(iu,"GPTJConfig"),iu.forEach(t),bi.forEach(t),ei=u(o),Gt=r(o,"DIV",{class:!0});var na=i(Gt);k(gn.$$.fragment,na),ol=u(na),mt=r(na,"P",{});var zt=i(mt);nl=s(zt,"This is the configuration class to store the configuration of a "),zs=r(zt,"A",{href:!0});var lu=i(zs);sl=s(lu,"GPTJModel"),lu.forEach(t),al=s(zt,`. It is used to instantiate a GPT-J
model according to the specified arguments, defining the model architecture. Instantiating a configuration with the
defaults will yield a similar configuration to that of the GPT-J
`),_n=r(zt,"A",{href:!0,rel:!0});var du=i(_n);rl=s(du,"EleutherAI/gpt-j-6B"),du.forEach(t),il=s(zt,` architecture. Configuration objects inherit from
`),As=r(zt,"A",{href:!0});var cu=i(As);ll=s(cu,"PretrainedConfig"),cu.forEach(t),dl=s(zt," and can be used to control the model outputs. Read the documentation from "),Is=r(zt,"A",{href:!0});var pu=i(Is);cl=s(pu,"PretrainedConfig"),pu.forEach(t),pl=s(zt,`
for more information.`),zt.forEach(t),hl=u(na),k(go.$$.fragment,na),na.forEach(t),ti=u(o),Wt=r(o,"H2",{class:!0});var $i=i(Wt);_o=r($i,"A",{id:!0,class:!0,href:!0});var hu=i(_o);ya=r(hu,"SPAN",{});var uu=i(ya);k(Tn.$$.fragment,uu),uu.forEach(t),hu.forEach(t),ul=u($i),va=r($i,"SPAN",{});var fu=i(va);fl=s(fu,"GPTJModel"),fu.forEach(t),$i.forEach(t),oi=u(o),Mt=r(o,"DIV",{class:!0});var sa=i(Mt);k(yn.$$.fragment,sa),ml=u(sa),vn=r(sa,"P",{});var Pi=i(vn);gl=s(Pi,`The bare GPT-J Model transformer outputting raw hidden-states without any specific head on top.
This model is a PyTorch `),wn=r(Pi,"A",{href:!0,rel:!0});var mu=i(wn);_l=s(mu,"torch.nn.Module"),mu.forEach(t),Tl=s(Pi,` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Pi.forEach(t),yl=u(sa),at=r(sa,"DIV",{class:!0});var At=i(at);k(kn.$$.fragment,At),vl=u(At),Ut=r(At,"P",{});var aa=i(Ut);wl=s(aa,"The "),Ls=r(aa,"A",{href:!0});var gu=i(Ls);kl=s(gu,"GPTJModel"),gu.forEach(t),bl=s(aa," forward method, overrides the "),wa=r(aa,"CODE",{});var _u=i(wa);$l=s(_u,"__call__"),_u.forEach(t),Pl=s(aa," special method."),aa.forEach(t),Fl=u(At),k(To.$$.fragment,At),jl=u(At),k(yo.$$.fragment,At),El=u(At),k(vo.$$.fragment,At),At.forEach(t),sa.forEach(t),ni=u(o),Qt=r(o,"H2",{class:!0});var Fi=i(Qt);wo=r(Fi,"A",{id:!0,class:!0,href:!0});var Tu=i(wo);ka=r(Tu,"SPAN",{});var yu=i(ka);k(bn.$$.fragment,yu),yu.forEach(t),Tu.forEach(t),xl=u(Fi),ba=r(Fi,"SPAN",{});var vu=i(ba);Gl=s(vu,"GPTJForCausalLM"),vu.forEach(t),Fi.forEach(t),si=u(o),gt=r(o,"DIV",{class:!0});var sn=i(gt);k($n.$$.fragment,sn),Ml=u(sn),$a=r(sn,"P",{});var wu=i($a);Jl=s(wu,"The GPT-J Model transformer with a language modeling head on top."),wu.forEach(t),ql=u(sn),Pn=r(sn,"P",{});var ji=i(Pn);Cl=s(ji,"This model is a PyTorch "),Fn=r(ji,"A",{href:!0,rel:!0});var ku=i(Fn);zl=s(ku,"torch.nn.Module"),ku.forEach(t),Al=s(ji,` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),ji.forEach(t),Il=u(sn),rt=r(sn,"DIV",{class:!0});var It=i(rt);k(jn.$$.fragment,It),Ll=u(It),Ht=r(It,"P",{});var ra=i(Ht);Ol=s(ra,"The "),Os=r(ra,"A",{href:!0});var bu=i(Os);Nl=s(bu,"GPTJForCausalLM"),bu.forEach(t),Dl=s(ra," forward method, overrides the "),Pa=r(ra,"CODE",{});var $u=i(Pa);Sl=s($u,"__call__"),$u.forEach(t),Bl=s(ra," special method."),ra.forEach(t),Wl=u(It),k(ko.$$.fragment,It),Ul=u(It),k(bo.$$.fragment,It),Ql=u(It),k($o.$$.fragment,It),It.forEach(t),sn.forEach(t),ai=u(o),Kt=r(o,"H2",{class:!0});var Ei=i(Kt);Po=r(Ei,"A",{id:!0,class:!0,href:!0});var Pu=i(Po);Fa=r(Pu,"SPAN",{});var Fu=i(Fa);k(En.$$.fragment,Fu),Fu.forEach(t),Pu.forEach(t),Hl=u(Ei),ja=r(Ei,"SPAN",{});var ju=i(ja);Kl=s(ju,"GPTJForSequenceClassification"),ju.forEach(t),Ei.forEach(t),ri=u(o),Se=r(o,"DIV",{class:!0});var Pt=i(Se);k(xn.$$.fragment,Pt),Rl=u(Pt),Ea=r(Pt,"P",{});var Eu=i(Ea);Vl=s(Eu,"The GPT-J Model transformer with a sequence classification head on top (linear layer)."),Eu.forEach(t),Xl=u(Pt),Ns=r(Pt,"P",{});var eu=i(Ns);Ds=r(eu,"A",{href:!0});var xu=i(Ds);Yl=s(xu,"GPTJForSequenceClassification"),xu.forEach(t),Zl=s(eu,` uses the last token in order to do the classification, as other causal models
(e.g. GPT, GPT-2, GPT-Neo) do.`),eu.forEach(t),ed=u(Pt),_t=r(Pt,"P",{});var Lt=i(_t);td=s(Lt,`Since it does classification on the last token, it requires to know the position of the last token. If a
`),xa=r(Lt,"CODE",{});var Gu=i(xa);od=s(Gu,"pad_token_id"),Gu.forEach(t),nd=s(Lt,` is defined in the configuration, it finds the last token that is not a padding token in each row. If
no `),Ga=r(Lt,"CODE",{});var Mu=i(Ga);sd=s(Mu,"pad_token_id"),Mu.forEach(t),ad=s(Lt,` is defined, it simply takes the last value in each row of the batch. Since it cannot guess the
padding tokens when `),Ma=r(Lt,"CODE",{});var Ju=i(Ma);rd=s(Ju,"inputs_embeds"),Ju.forEach(t),id=s(Lt," are passed instead of "),Ja=r(Lt,"CODE",{});var qu=i(Ja);ld=s(qu,"input_ids"),qu.forEach(t),dd=s(Lt,`, it does the same (take the last value in
each row of the batch).`),Lt.forEach(t),cd=u(Pt),Gn=r(Pt,"P",{});var xi=i(Gn);pd=s(xi,"This model is a PyTorch "),Mn=r(xi,"A",{href:!0,rel:!0});var Cu=i(Mn);hd=s(Cu,"torch.nn.Module"),Cu.forEach(t),ud=s(xi,` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),xi.forEach(t),fd=u(Pt),Ke=r(Pt,"DIV",{class:!0});var Ft=i(Ke);k(Jn.$$.fragment,Ft),md=u(Ft),Rt=r(Ft,"P",{});var ia=i(Rt);gd=s(ia,"The "),Ss=r(ia,"A",{href:!0});var zu=i(Ss);_d=s(zu,"GPTJForSequenceClassification"),zu.forEach(t),Td=s(ia," forward method, overrides the "),qa=r(ia,"CODE",{});var Au=i(qa);yd=s(Au,"__call__"),Au.forEach(t),vd=s(ia," special method."),ia.forEach(t),wd=u(Ft),k(Fo.$$.fragment,Ft),kd=u(Ft),k(jo.$$.fragment,Ft),bd=u(Ft),k(Eo.$$.fragment,Ft),$d=u(Ft),k(xo.$$.fragment,Ft),Ft.forEach(t),Pt.forEach(t),ii=u(o),Vt=r(o,"H2",{class:!0});var Gi=i(Vt);Go=r(Gi,"A",{id:!0,class:!0,href:!0});var Iu=i(Go);Ca=r(Iu,"SPAN",{});var Lu=i(Ca);k(qn.$$.fragment,Lu),Lu.forEach(t),Iu.forEach(t),Pd=u(Gi),za=r(Gi,"SPAN",{});var Ou=i(za);Fd=s(Ou,"GPTJForQuestionAnswering"),Ou.forEach(t),Gi.forEach(t),li=u(o),Tt=r(o,"DIV",{class:!0});var an=i(Tt);k(Cn.$$.fragment,an),jd=u(an),Xt=r(an,"P",{});var la=i(Xt);Ed=s(la,`The GPT-J Model transformer with a span classification head on top for extractive question-answering tasks like
SQuAD (a linear layers on top of the hidden-states output to compute `),Aa=r(la,"CODE",{});var Nu=i(Aa);xd=s(Nu,"span start logits"),Nu.forEach(t),Gd=s(la," and "),Ia=r(la,"CODE",{});var Du=i(Ia);Md=s(Du,"span end logits"),Du.forEach(t),Jd=s(la,")."),la.forEach(t),qd=u(an),zn=r(an,"P",{});var Mi=i(zn);Cd=s(Mi,"This model is a PyTorch "),An=r(Mi,"A",{href:!0,rel:!0});var Su=i(An);zd=s(Su,"torch.nn.Module"),Su.forEach(t),Ad=s(Mi,` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Mi.forEach(t),Id=u(an),it=r(an,"DIV",{class:!0});var Ot=i(it);k(In.$$.fragment,Ot),Ld=u(Ot),Yt=r(Ot,"P",{});var da=i(Yt);Od=s(da,"The "),Bs=r(da,"A",{href:!0});var Bu=i(Bs);Nd=s(Bu,"GPTJForQuestionAnswering"),Bu.forEach(t),Dd=s(da," forward method, overrides the "),La=r(da,"CODE",{});var Wu=i(La);Sd=s(Wu,"__call__"),Wu.forEach(t),Bd=s(da," special method."),da.forEach(t),Wd=u(Ot),k(Mo.$$.fragment,Ot),Ud=u(Ot),k(Jo.$$.fragment,Ot),Qd=u(Ot),k(qo.$$.fragment,Ot),Ot.forEach(t),an.forEach(t),di=u(o),Zt=r(o,"H2",{class:!0});var Ji=i(Zt);Co=r(Ji,"A",{id:!0,class:!0,href:!0});var Uu=i(Co);Oa=r(Uu,"SPAN",{});var Qu=i(Oa);k(Ln.$$.fragment,Qu),Qu.forEach(t),Uu.forEach(t),Hd=u(Ji),Na=r(Ji,"SPAN",{});var Hu=i(Na);Kd=s(Hu,"TFGPTJModel"),Hu.forEach(t),Ji.forEach(t),ci=u(o),Be=r(o,"DIV",{class:!0});var jt=i(Be);k(On.$$.fragment,jt),Rd=u(jt),Da=r(jt,"P",{});var Ku=i(Da);Vd=s(Ku,"The bare GPT-J Model transformer outputting raw hidden-states without any specific head on top."),Ku.forEach(t),Xd=u(jt),Nn=r(jt,"P",{});var qi=i(Nn);Yd=s(qi,"This model inherits from "),Ws=r(qi,"A",{href:!0});var Ru=i(Ws);Zd=s(Ru,"TFPreTrainedModel"),Ru.forEach(t),ec=s(qi,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),qi.forEach(t),tc=u(jt),Dn=r(jt,"P",{});var Ci=i(Dn);oc=s(Ci,"This model is also a "),Sn=r(Ci,"A",{href:!0,rel:!0});var Vu=i(Sn);nc=s(Vu,"tf.keras.Model"),Vu.forEach(t),sc=s(Ci,` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),Ci.forEach(t),ac=u(jt),k(zo.$$.fragment,jt),rc=u(jt),wt=r(jt,"DIV",{class:!0});var rn=i(wt);k(Bn.$$.fragment,rn),ic=u(rn),eo=r(rn,"P",{});var ca=i(eo);lc=s(ca,"The "),Us=r(ca,"A",{href:!0});var Xu=i(Us);dc=s(Xu,"TFGPTJModel"),Xu.forEach(t),cc=s(ca," forward method, overrides the "),Sa=r(ca,"CODE",{});var Yu=i(Sa);pc=s(Yu,"__call__"),Yu.forEach(t),hc=s(ca," special method."),ca.forEach(t),uc=u(rn),k(Ao.$$.fragment,rn),fc=u(rn),k(Io.$$.fragment,rn),rn.forEach(t),jt.forEach(t),pi=u(o),to=r(o,"H2",{class:!0});var zi=i(to);Lo=r(zi,"A",{id:!0,class:!0,href:!0});var Zu=i(Lo);Ba=r(Zu,"SPAN",{});var ef=i(Ba);k(Wn.$$.fragment,ef),ef.forEach(t),Zu.forEach(t),mc=u(zi),Wa=r(zi,"SPAN",{});var tf=i(Wa);gc=s(tf,"TFGPTJForCausalLM"),tf.forEach(t),zi.forEach(t),hi=u(o),We=r(o,"DIV",{class:!0});var Et=i(We);k(Un.$$.fragment,Et),_c=u(Et),Ua=r(Et,"P",{});var of=i(Ua);Tc=s(of,"The GPT-J Model transformer with a language modeling head on top."),of.forEach(t),yc=u(Et),Qn=r(Et,"P",{});var Ai=i(Qn);vc=s(Ai,"This model inherits from "),Qs=r(Ai,"A",{href:!0});var nf=i(Qs);wc=s(nf,"TFPreTrainedModel"),nf.forEach(t),kc=s(Ai,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Ai.forEach(t),bc=u(Et),Hn=r(Et,"P",{});var Ii=i(Hn);$c=s(Ii,"This model is also a "),Kn=r(Ii,"A",{href:!0,rel:!0});var sf=i(Kn);Pc=s(sf,"tf.keras.Model"),sf.forEach(t),Fc=s(Ii,` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),Ii.forEach(t),jc=u(Et),k(Oo.$$.fragment,Et),Ec=u(Et),kt=r(Et,"DIV",{class:!0});var ln=i(kt);k(Rn.$$.fragment,ln),xc=u(ln),oo=r(ln,"P",{});var pa=i(oo);Gc=s(pa,"The "),Hs=r(pa,"A",{href:!0});var af=i(Hs);Mc=s(af,"TFGPTJForCausalLM"),af.forEach(t),Jc=s(pa," forward method, overrides the "),Qa=r(pa,"CODE",{});var rf=i(Qa);qc=s(rf,"__call__"),rf.forEach(t),Cc=s(pa," special method."),pa.forEach(t),zc=u(ln),k(No.$$.fragment,ln),Ac=u(ln),k(Do.$$.fragment,ln),ln.forEach(t),Et.forEach(t),ui=u(o),no=r(o,"H2",{class:!0});var Li=i(no);So=r(Li,"A",{id:!0,class:!0,href:!0});var lf=i(So);Ha=r(lf,"SPAN",{});var df=i(Ha);k(Vn.$$.fragment,df),df.forEach(t),lf.forEach(t),Ic=u(Li),Ka=r(Li,"SPAN",{});var cf=i(Ka);Lc=s(cf,"TFGPTJForSequenceClassification"),cf.forEach(t),Li.forEach(t),fi=u(o),ge=r(o,"DIV",{class:!0});var Re=i(ge);k(Xn.$$.fragment,Re),Oc=u(Re),Ra=r(Re,"P",{});var pf=i(Ra);Nc=s(pf,"The GPT-J Model transformer with a sequence classification head on top (linear layer)."),pf.forEach(t),Dc=u(Re),Ks=r(Re,"P",{});var tu=i(Ks);Rs=r(tu,"A",{href:!0});var hf=i(Rs);Sc=s(hf,"GPTJForSequenceClassification"),hf.forEach(t),Bc=s(tu,` uses the last token in order to do the classification, as other causal models
(e.g. GPT, GPT-2, GPT-Neo) do.`),tu.forEach(t),Wc=u(Re),yt=r(Re,"P",{});var Nt=i(yt);Uc=s(Nt,`Since it does classification on the last token, it requires to know the position of the last token. If a
`),Va=r(Nt,"CODE",{});var uf=i(Va);Qc=s(uf,"pad_token_id"),uf.forEach(t),Hc=s(Nt,` is defined in the configuration, it finds the last token that is not a padding token in each row. If
no `),Xa=r(Nt,"CODE",{});var ff=i(Xa);Kc=s(ff,"pad_token_id"),ff.forEach(t),Rc=s(Nt,` is defined, it simply takes the last value in each row of the batch. Since it cannot guess the
padding tokens when `),Ya=r(Nt,"CODE",{});var mf=i(Ya);Vc=s(mf,"inputs_embeds"),mf.forEach(t),Xc=s(Nt," are passed instead of "),Za=r(Nt,"CODE",{});var gf=i(Za);Yc=s(gf,"input_ids"),gf.forEach(t),Zc=s(Nt,`, it does the same (take the last value in
each row of the batch).`),Nt.forEach(t),ep=u(Re),Yn=r(Re,"P",{});var Oi=i(Yn);tp=s(Oi,"This model inherits from "),Vs=r(Oi,"A",{href:!0});var _f=i(Vs);op=s(_f,"TFPreTrainedModel"),_f.forEach(t),np=s(Oi,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Oi.forEach(t),sp=u(Re),Zn=r(Re,"P",{});var Ni=i(Zn);ap=s(Ni,"This model is also a "),es=r(Ni,"A",{href:!0,rel:!0});var Tf=i(es);rp=s(Tf,"tf.keras.Model"),Tf.forEach(t),ip=s(Ni,` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),Ni.forEach(t),lp=u(Re),k(Bo.$$.fragment,Re),dp=u(Re),lt=r(Re,"DIV",{class:!0});var Dt=i(lt);k(ts.$$.fragment,Dt),cp=u(Dt),so=r(Dt,"P",{});var ha=i(so);pp=s(ha,"The "),Xs=r(ha,"A",{href:!0});var yf=i(Xs);hp=s(yf,"TFGPTJForSequenceClassification"),yf.forEach(t),up=s(ha," forward method, overrides the "),er=r(ha,"CODE",{});var vf=i(er);fp=s(vf,"__call__"),vf.forEach(t),mp=s(ha," special method."),ha.forEach(t),gp=u(Dt),k(Wo.$$.fragment,Dt),_p=u(Dt),k(Uo.$$.fragment,Dt),Tp=u(Dt),k(Qo.$$.fragment,Dt),Dt.forEach(t),Re.forEach(t),mi=u(o),ao=r(o,"H2",{class:!0});var Di=i(ao);Ho=r(Di,"A",{id:!0,class:!0,href:!0});var wf=i(Ho);tr=r(wf,"SPAN",{});var kf=i(tr);k(os.$$.fragment,kf),kf.forEach(t),wf.forEach(t),yp=u(Di),or=r(Di,"SPAN",{});var bf=i(or);vp=s(bf,"TFGPTJForQuestionAnswering"),bf.forEach(t),Di.forEach(t),gi=u(o),Ue=r(o,"DIV",{class:!0});var xt=i(Ue);k(ns.$$.fragment,xt),wp=u(xt),ro=r(xt,"P",{});var ua=i(ro);kp=s(ua,`The GPT-J Model transformer with a span classification head on top for extractive question-answering tasks like
SQuAD (a linear layers on top of the hidden-states output to compute `),nr=r(ua,"CODE",{});var $f=i(nr);bp=s($f,"span start logits"),$f.forEach(t),$p=s(ua," and "),sr=r(ua,"CODE",{});var Pf=i(sr);Pp=s(Pf,"span end logits"),Pf.forEach(t),Fp=s(ua,")."),ua.forEach(t),jp=u(xt),ss=r(xt,"P",{});var Si=i(ss);Ep=s(Si,"This model inherits from "),Ys=r(Si,"A",{href:!0});var Ff=i(Ys);xp=s(Ff,"TFPreTrainedModel"),Ff.forEach(t),Gp=s(Si,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Si.forEach(t),Mp=u(xt),as=r(xt,"P",{});var Bi=i(as);Jp=s(Bi,"This model is also a "),rs=r(Bi,"A",{href:!0,rel:!0});var jf=i(rs);qp=s(jf,"tf.keras.Model"),jf.forEach(t),Cp=s(Bi,` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),Bi.forEach(t),zp=u(xt),k(Ko.$$.fragment,xt),Ap=u(xt),dt=r(xt,"DIV",{class:!0});var St=i(dt);k(is.$$.fragment,St),Ip=u(St),io=r(St,"P",{});var fa=i(io);Lp=s(fa,"The "),Zs=r(fa,"A",{href:!0});var Ef=i(Zs);Op=s(Ef,"TFGPTJForQuestionAnswering"),Ef.forEach(t),Np=s(fa," forward method, overrides the "),ar=r(fa,"CODE",{});var xf=i(ar);Dp=s(xf,"__call__"),xf.forEach(t),Sp=s(fa," special method."),fa.forEach(t),Bp=u(St),k(Ro.$$.fragment,St),Wp=u(St),k(Vo.$$.fragment,St),Up=u(St),k(Xo.$$.fragment,St),St.forEach(t),xt.forEach(t),_i=u(o),lo=r(o,"H2",{class:!0});var Wi=i(lo);Yo=r(Wi,"A",{id:!0,class:!0,href:!0});var Gf=i(Yo);rr=r(Gf,"SPAN",{});var Mf=i(rr);k(ls.$$.fragment,Mf),Mf.forEach(t),Gf.forEach(t),Qp=u(Wi),ir=r(Wi,"SPAN",{});var Jf=i(ir);Hp=s(Jf,"FlaxGPTJModel"),Jf.forEach(t),Wi.forEach(t),Ti=u(o),Ie=r(o,"DIV",{class:!0});var ct=i(Ie);k(ds.$$.fragment,ct),Kp=u(ct),lr=r(ct,"P",{});var qf=i(lr);Rp=s(qf,"The bare GPTJ Model transformer outputting raw hidden-states without any specific head on top."),qf.forEach(t),Vp=u(ct),cs=r(ct,"P",{});var Ui=i(cs);Xp=s(Ui,"This model inherits from "),ea=r(Ui,"A",{href:!0});var Cf=i(ea);Yp=s(Cf,"FlaxPreTrainedModel"),Cf.forEach(t),Zp=s(Ui,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Ui.forEach(t),eh=u(ct),ps=r(ct,"P",{});var Qi=i(ps);th=s(Qi,`This model is also a Flax Linen
`),hs=r(Qi,"A",{href:!0,rel:!0});var zf=i(hs);oh=s(zf,"flax.nn.Module"),zf.forEach(t),nh=s(Qi,` subclass. Use it as a
regular Flax Module and refer to the Flax documentation for all matter related to general usage and behavior.`),Qi.forEach(t),sh=u(ct),dr=r(ct,"P",{});var Af=i(dr);ah=s(Af,"Finally, this model supports inherent JAX features such as:"),Af.forEach(t),rh=u(ct),Jt=r(ct,"UL",{});var dn=i(Jt);cr=r(dn,"LI",{});var If=i(cr);us=r(If,"A",{href:!0,rel:!0});var Lf=i(us);ih=s(Lf,"Just-In-Time (JIT) compilation"),Lf.forEach(t),If.forEach(t),lh=u(dn),pr=r(dn,"LI",{});var Of=i(pr);fs=r(Of,"A",{href:!0,rel:!0});var Nf=i(fs);dh=s(Nf,"Automatic Differentiation"),Nf.forEach(t),Of.forEach(t),ch=u(dn),hr=r(dn,"LI",{});var Df=i(hr);ms=r(Df,"A",{href:!0,rel:!0});var Sf=i(ms);ph=s(Sf,"Vectorization"),Sf.forEach(t),Df.forEach(t),hh=u(dn),ur=r(dn,"LI",{});var Bf=i(ur);gs=r(Bf,"A",{href:!0,rel:!0});var Wf=i(gs);uh=s(Wf,"Parallelization"),Wf.forEach(t),Bf.forEach(t),dn.forEach(t),fh=u(ct),bt=r(ct,"DIV",{class:!0});var cn=i(bt);k(_s.$$.fragment,cn),mh=u(cn),co=r(cn,"P",{});var ma=i(co);gh=s(ma,"The "),fr=r(ma,"CODE",{});var Uf=i(fr);_h=s(Uf,"FlaxGPTJPreTrainedModel"),Uf.forEach(t),Th=s(ma," forward method, overrides the "),mr=r(ma,"CODE",{});var Qf=i(mr);yh=s(Qf,"__call__"),Qf.forEach(t),vh=s(ma," special method."),ma.forEach(t),wh=u(cn),k(Zo.$$.fragment,cn),kh=u(cn),k(en.$$.fragment,cn),cn.forEach(t),ct.forEach(t),yi=u(o),po=r(o,"H2",{class:!0});var Hi=i(po);tn=r(Hi,"A",{id:!0,class:!0,href:!0});var Hf=i(tn);gr=r(Hf,"SPAN",{});var Kf=i(gr);k(Ts.$$.fragment,Kf),Kf.forEach(t),Hf.forEach(t),bh=u(Hi),_r=r(Hi,"SPAN",{});var Rf=i(_r);$h=s(Rf,"FlaxGPTJForCausalLM"),Rf.forEach(t),Hi.forEach(t),vi=u(o),Le=r(o,"DIV",{class:!0});var pt=i(Le);k(ys.$$.fragment,pt),Ph=u(pt),Tr=r(pt,"P",{});var Vf=i(Tr);Fh=s(Vf,"The GPTJ Model transformer with a language modeling head on top."),Vf.forEach(t),jh=u(pt),vs=r(pt,"P",{});var Ki=i(vs);Eh=s(Ki,"This model inherits from "),ta=r(Ki,"A",{href:!0});var Xf=i(ta);xh=s(Xf,"FlaxPreTrainedModel"),Xf.forEach(t),Gh=s(Ki,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Ki.forEach(t),Mh=u(pt),ws=r(pt,"P",{});var Ri=i(ws);Jh=s(Ri,`This model is also a Flax Linen
`),ks=r(Ri,"A",{href:!0,rel:!0});var Yf=i(ks);qh=s(Yf,"flax.nn.Module"),Yf.forEach(t),Ch=s(Ri,` subclass. Use it as a
regular Flax Module and refer to the Flax documentation for all matter related to general usage and behavior.`),Ri.forEach(t),zh=u(pt),yr=r(pt,"P",{});var Zf=i(yr);Ah=s(Zf,"Finally, this model supports inherent JAX features such as:"),Zf.forEach(t),Ih=u(pt),qt=r(pt,"UL",{});var pn=i(qt);vr=r(pn,"LI",{});var em=i(vr);bs=r(em,"A",{href:!0,rel:!0});var tm=i(bs);Lh=s(tm,"Just-In-Time (JIT) compilation"),tm.forEach(t),em.forEach(t),Oh=u(pn),wr=r(pn,"LI",{});var om=i(wr);$s=r(om,"A",{href:!0,rel:!0});var nm=i($s);Nh=s(nm,"Automatic Differentiation"),nm.forEach(t),om.forEach(t),Dh=u(pn),kr=r(pn,"LI",{});var sm=i(kr);Ps=r(sm,"A",{href:!0,rel:!0});var am=i(Ps);Sh=s(am,"Vectorization"),am.forEach(t),sm.forEach(t),Bh=u(pn),br=r(pn,"LI",{});var rm=i(br);Fs=r(rm,"A",{href:!0,rel:!0});var im=i(Fs);Wh=s(im,"Parallelization"),im.forEach(t),rm.forEach(t),pn.forEach(t),Uh=u(pt),$t=r(pt,"DIV",{class:!0});var hn=i($t);k(js.$$.fragment,hn),Qh=u(hn),ho=r(hn,"P",{});var ga=i(ho);Hh=s(ga,"The "),$r=r(ga,"CODE",{});var lm=i($r);Kh=s(lm,"FlaxGPTJPreTrainedModel"),lm.forEach(t),Rh=s(ga," forward method, overrides the "),Pr=r(ga,"CODE",{});var dm=i(Pr);Vh=s(dm,"__call__"),dm.forEach(t),Xh=s(ga," special method."),ga.forEach(t),Yh=u(hn),k(on.$$.fragment,hn),Zh=u(hn),k(nn.$$.fragment,hn),hn.forEach(t),pt.forEach(t),this.h()},h(){m(d,"name","hf:doc:metadata"),m(d,"content",JSON.stringify(Km)),m(f,"id","gptj"),m(f,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(f,"href","#gptj"),m(p,"class","relative group"),m(D,"id","overview"),m(D,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(D,"href","#overview"),m(C,"class","relative group"),m(re,"href","https://github.com/kingoflolz/mesh-transformer-jax"),m(re,"rel","nofollow"),m(ie,"href","https://pile.eleuther.ai/"),m(ie,"rel","nofollow"),m(le,"href","https://huggingface.co/stellaathena"),m(le,"rel","nofollow"),m(ce,"href","https://huggingface.co/EleutherAI/gpt-j-6B"),m(ce,"rel","nofollow"),m(S,"href","https://huggingface.co/EleutherAI/gpt-j-6B/tree/float16"),m(S,"rel","nofollow"),m(v,"href","https://github.com/kingoflolz/mesh-transformer-jax/blob/master/howto_finetune.md"),m(v,"rel","nofollow"),m(M,"href","https://huggingface.co/EleutherAI/gpt-j-6B"),m(M,"rel","nofollow"),m(ke,"id","generation"),m(ke,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(ke,"href","#generation"),m(U,"class","relative group"),m(qs,"href","/docs/transformers/v4.26.0/en/main_classes/text_generation#transformers.GenerationMixin.generate"),m(mo,"id","transformers.GPTJConfig"),m(mo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(mo,"href","#transformers.GPTJConfig"),m(Bt,"class","relative group"),m(zs,"href","/docs/transformers/v4.26.0/en/model_doc/gptj#transformers.GPTJModel"),m(_n,"href","https://huggingface.co/EleutherAI/gpt-j-6B"),m(_n,"rel","nofollow"),m(As,"href","/docs/transformers/v4.26.0/en/main_classes/configuration#transformers.PretrainedConfig"),m(Is,"href","/docs/transformers/v4.26.0/en/main_classes/configuration#transformers.PretrainedConfig"),m(Gt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(_o,"id","transformers.GPTJModel"),m(_o,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(_o,"href","#transformers.GPTJModel"),m(Wt,"class","relative group"),m(wn,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),m(wn,"rel","nofollow"),m(Ls,"href","/docs/transformers/v4.26.0/en/model_doc/gptj#transformers.GPTJModel"),m(at,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(Mt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(wo,"id","transformers.GPTJForCausalLM"),m(wo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(wo,"href","#transformers.GPTJForCausalLM"),m(Qt,"class","relative group"),m(Fn,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),m(Fn,"rel","nofollow"),m(Os,"href","/docs/transformers/v4.26.0/en/model_doc/gptj#transformers.GPTJForCausalLM"),m(rt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(gt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(Po,"id","transformers.GPTJForSequenceClassification"),m(Po,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(Po,"href","#transformers.GPTJForSequenceClassification"),m(Kt,"class","relative group"),m(Ds,"href","/docs/transformers/v4.26.0/en/model_doc/gptj#transformers.GPTJForSequenceClassification"),m(Mn,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),m(Mn,"rel","nofollow"),m(Ss,"href","/docs/transformers/v4.26.0/en/model_doc/gptj#transformers.GPTJForSequenceClassification"),m(Ke,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(Se,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(Go,"id","transformers.GPTJForQuestionAnswering"),m(Go,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(Go,"href","#transformers.GPTJForQuestionAnswering"),m(Vt,"class","relative group"),m(An,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),m(An,"rel","nofollow"),m(Bs,"href","/docs/transformers/v4.26.0/en/model_doc/gptj#transformers.GPTJForQuestionAnswering"),m(it,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(Tt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(Co,"id","transformers.TFGPTJModel"),m(Co,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(Co,"href","#transformers.TFGPTJModel"),m(Zt,"class","relative group"),m(Ws,"href","/docs/transformers/v4.26.0/en/main_classes/model#transformers.TFPreTrainedModel"),m(Sn,"href","https://www.tensorflow.org/api_docs/python/tf/keras/Model"),m(Sn,"rel","nofollow"),m(Us,"href","/docs/transformers/v4.26.0/en/model_doc/gptj#transformers.TFGPTJModel"),m(wt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(Be,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(Lo,"id","transformers.TFGPTJForCausalLM"),m(Lo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(Lo,"href","#transformers.TFGPTJForCausalLM"),m(to,"class","relative group"),m(Qs,"href","/docs/transformers/v4.26.0/en/main_classes/model#transformers.TFPreTrainedModel"),m(Kn,"href","https://www.tensorflow.org/api_docs/python/tf/keras/Model"),m(Kn,"rel","nofollow"),m(Hs,"href","/docs/transformers/v4.26.0/en/model_doc/gptj#transformers.TFGPTJForCausalLM"),m(kt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(We,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(So,"id","transformers.TFGPTJForSequenceClassification"),m(So,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(So,"href","#transformers.TFGPTJForSequenceClassification"),m(no,"class","relative group"),m(Rs,"href","/docs/transformers/v4.26.0/en/model_doc/gptj#transformers.GPTJForSequenceClassification"),m(Vs,"href","/docs/transformers/v4.26.0/en/main_classes/model#transformers.TFPreTrainedModel"),m(es,"href","https://www.tensorflow.org/api_docs/python/tf/keras/Model"),m(es,"rel","nofollow"),m(Xs,"href","/docs/transformers/v4.26.0/en/model_doc/gptj#transformers.TFGPTJForSequenceClassification"),m(lt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(ge,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(Ho,"id","transformers.TFGPTJForQuestionAnswering"),m(Ho,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(Ho,"href","#transformers.TFGPTJForQuestionAnswering"),m(ao,"class","relative group"),m(Ys,"href","/docs/transformers/v4.26.0/en/main_classes/model#transformers.TFPreTrainedModel"),m(rs,"href","https://www.tensorflow.org/api_docs/python/tf/keras/Model"),m(rs,"rel","nofollow"),m(Zs,"href","/docs/transformers/v4.26.0/en/model_doc/gptj#transformers.TFGPTJForQuestionAnswering"),m(dt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(Ue,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(Yo,"id","transformers.FlaxGPTJModel"),m(Yo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(Yo,"href","#transformers.FlaxGPTJModel"),m(lo,"class","relative group"),m(ea,"href","/docs/transformers/v4.26.0/en/main_classes/model#transformers.FlaxPreTrainedModel"),m(hs,"href","https://flax.readthedocs.io/en/latest/_autosummary/flax.nn.module.html"),m(hs,"rel","nofollow"),m(us,"href","https://jax.readthedocs.io/en/latest/jax.html#just-in-time-compilation-jit"),m(us,"rel","nofollow"),m(fs,"href","https://jax.readthedocs.io/en/latest/jax.html#automatic-differentiation"),m(fs,"rel","nofollow"),m(ms,"href","https://jax.readthedocs.io/en/latest/jax.html#vectorization-vmap"),m(ms,"rel","nofollow"),m(gs,"href","https://jax.readthedocs.io/en/latest/jax.html#parallelization-pmap"),m(gs,"rel","nofollow"),m(bt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(Ie,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(tn,"id","transformers.FlaxGPTJForCausalLM"),m(tn,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(tn,"href","#transformers.FlaxGPTJForCausalLM"),m(po,"class","relative group"),m(ta,"href","/docs/transformers/v4.26.0/en/main_classes/model#transformers.FlaxPreTrainedModel"),m(ks,"href","https://flax.readthedocs.io/en/latest/_autosummary/flax.nn.module.html"),m(ks,"rel","nofollow"),m(bs,"href","https://jax.readthedocs.io/en/latest/jax.html#just-in-time-compilation-jit"),m(bs,"rel","nofollow"),m($s,"href","https://jax.readthedocs.io/en/latest/jax.html#automatic-differentiation"),m($s,"rel","nofollow"),m(Ps,"href","https://jax.readthedocs.io/en/latest/jax.html#vectorization-vmap"),m(Ps,"rel","nofollow"),m(Fs,"href","https://jax.readthedocs.io/en/latest/jax.html#parallelization-pmap"),m(Fs,"rel","nofollow"),m($t,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(Le,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(o,_){e(document.head,d),g(o,y,_),g(o,p,_),e(p,f),e(f,T),b(l,T,null),e(p,c),e(p,j),e(j,z),g(o,J,_),g(o,C,_),e(C,D),e(D,oe),b(E,oe,null),e(C,be),e(C,H),e(H,$e),g(o,Te,_),g(o,B,_),e(B,Pe),e(B,re),e(re,V),e(B,Fe),e(B,ie),e(ie,X),e(B,je),g(o,ye,_),g(o,Q,_),e(Q,Ee),e(Q,le),e(le,de),e(Q,q),g(o,A,_),g(o,ue,_),e(ue,Y),g(o,ve,_),g(o,fe,_),e(fe,O),e(O,xe),e(O,ce),e(ce,L),e(O,Ge),e(O,K),e(K,Me),e(O,Je),e(O,R),e(R,qe),e(O,Ce),e(O,S),e(S,ze),e(O,Z),g(o,we,_),b(ee,o,_),g(o,I,_),g(o,ae,_),e(ae,N),e(N,me),e(me,Ae),e(me,v),e(v,G),e(ae,Ve),e(ae,ne),e(ne,pe),e(pe,Xe),e(pe,M),e(M,Ye),e(pe,Ze),e(pe,Ne),e(Ne,et),e(pe,tt),e(pe,W),e(W,te),e(pe,ot),g(o,He,_),g(o,U,_),e(U,ke),e(ke,De),b(he,De,null),e(U,nt),e(U,se),e(se,st),g(o,Rr,_),g(o,fo,_),e(fo,Vi),e(fo,qs),e(qs,Xi),e(fo,Yi),g(o,Vr,_),b(un,o,_),g(o,Xr,_),g(o,Cs,_),e(Cs,Zi),g(o,Yr,_),b(fn,o,_),g(o,Zr,_),g(o,Bt,_),e(Bt,mo),e(mo,_a),b(mn,_a,null),e(Bt,el),e(Bt,Ta),e(Ta,tl),g(o,ei,_),g(o,Gt,_),b(gn,Gt,null),e(Gt,ol),e(Gt,mt),e(mt,nl),e(mt,zs),e(zs,sl),e(mt,al),e(mt,_n),e(_n,rl),e(mt,il),e(mt,As),e(As,ll),e(mt,dl),e(mt,Is),e(Is,cl),e(mt,pl),e(Gt,hl),b(go,Gt,null),g(o,ti,_),g(o,Wt,_),e(Wt,_o),e(_o,ya),b(Tn,ya,null),e(Wt,ul),e(Wt,va),e(va,fl),g(o,oi,_),g(o,Mt,_),b(yn,Mt,null),e(Mt,ml),e(Mt,vn),e(vn,gl),e(vn,wn),e(wn,_l),e(vn,Tl),e(Mt,yl),e(Mt,at),b(kn,at,null),e(at,vl),e(at,Ut),e(Ut,wl),e(Ut,Ls),e(Ls,kl),e(Ut,bl),e(Ut,wa),e(wa,$l),e(Ut,Pl),e(at,Fl),b(To,at,null),e(at,jl),b(yo,at,null),e(at,El),b(vo,at,null),g(o,ni,_),g(o,Qt,_),e(Qt,wo),e(wo,ka),b(bn,ka,null),e(Qt,xl),e(Qt,ba),e(ba,Gl),g(o,si,_),g(o,gt,_),b($n,gt,null),e(gt,Ml),e(gt,$a),e($a,Jl),e(gt,ql),e(gt,Pn),e(Pn,Cl),e(Pn,Fn),e(Fn,zl),e(Pn,Al),e(gt,Il),e(gt,rt),b(jn,rt,null),e(rt,Ll),e(rt,Ht),e(Ht,Ol),e(Ht,Os),e(Os,Nl),e(Ht,Dl),e(Ht,Pa),e(Pa,Sl),e(Ht,Bl),e(rt,Wl),b(ko,rt,null),e(rt,Ul),b(bo,rt,null),e(rt,Ql),b($o,rt,null),g(o,ai,_),g(o,Kt,_),e(Kt,Po),e(Po,Fa),b(En,Fa,null),e(Kt,Hl),e(Kt,ja),e(ja,Kl),g(o,ri,_),g(o,Se,_),b(xn,Se,null),e(Se,Rl),e(Se,Ea),e(Ea,Vl),e(Se,Xl),e(Se,Ns),e(Ns,Ds),e(Ds,Yl),e(Ns,Zl),e(Se,ed),e(Se,_t),e(_t,td),e(_t,xa),e(xa,od),e(_t,nd),e(_t,Ga),e(Ga,sd),e(_t,ad),e(_t,Ma),e(Ma,rd),e(_t,id),e(_t,Ja),e(Ja,ld),e(_t,dd),e(Se,cd),e(Se,Gn),e(Gn,pd),e(Gn,Mn),e(Mn,hd),e(Gn,ud),e(Se,fd),e(Se,Ke),b(Jn,Ke,null),e(Ke,md),e(Ke,Rt),e(Rt,gd),e(Rt,Ss),e(Ss,_d),e(Rt,Td),e(Rt,qa),e(qa,yd),e(Rt,vd),e(Ke,wd),b(Fo,Ke,null),e(Ke,kd),b(jo,Ke,null),e(Ke,bd),b(Eo,Ke,null),e(Ke,$d),b(xo,Ke,null),g(o,ii,_),g(o,Vt,_),e(Vt,Go),e(Go,Ca),b(qn,Ca,null),e(Vt,Pd),e(Vt,za),e(za,Fd),g(o,li,_),g(o,Tt,_),b(Cn,Tt,null),e(Tt,jd),e(Tt,Xt),e(Xt,Ed),e(Xt,Aa),e(Aa,xd),e(Xt,Gd),e(Xt,Ia),e(Ia,Md),e(Xt,Jd),e(Tt,qd),e(Tt,zn),e(zn,Cd),e(zn,An),e(An,zd),e(zn,Ad),e(Tt,Id),e(Tt,it),b(In,it,null),e(it,Ld),e(it,Yt),e(Yt,Od),e(Yt,Bs),e(Bs,Nd),e(Yt,Dd),e(Yt,La),e(La,Sd),e(Yt,Bd),e(it,Wd),b(Mo,it,null),e(it,Ud),b(Jo,it,null),e(it,Qd),b(qo,it,null),g(o,di,_),g(o,Zt,_),e(Zt,Co),e(Co,Oa),b(Ln,Oa,null),e(Zt,Hd),e(Zt,Na),e(Na,Kd),g(o,ci,_),g(o,Be,_),b(On,Be,null),e(Be,Rd),e(Be,Da),e(Da,Vd),e(Be,Xd),e(Be,Nn),e(Nn,Yd),e(Nn,Ws),e(Ws,Zd),e(Nn,ec),e(Be,tc),e(Be,Dn),e(Dn,oc),e(Dn,Sn),e(Sn,nc),e(Dn,sc),e(Be,ac),b(zo,Be,null),e(Be,rc),e(Be,wt),b(Bn,wt,null),e(wt,ic),e(wt,eo),e(eo,lc),e(eo,Us),e(Us,dc),e(eo,cc),e(eo,Sa),e(Sa,pc),e(eo,hc),e(wt,uc),b(Ao,wt,null),e(wt,fc),b(Io,wt,null),g(o,pi,_),g(o,to,_),e(to,Lo),e(Lo,Ba),b(Wn,Ba,null),e(to,mc),e(to,Wa),e(Wa,gc),g(o,hi,_),g(o,We,_),b(Un,We,null),e(We,_c),e(We,Ua),e(Ua,Tc),e(We,yc),e(We,Qn),e(Qn,vc),e(Qn,Qs),e(Qs,wc),e(Qn,kc),e(We,bc),e(We,Hn),e(Hn,$c),e(Hn,Kn),e(Kn,Pc),e(Hn,Fc),e(We,jc),b(Oo,We,null),e(We,Ec),e(We,kt),b(Rn,kt,null),e(kt,xc),e(kt,oo),e(oo,Gc),e(oo,Hs),e(Hs,Mc),e(oo,Jc),e(oo,Qa),e(Qa,qc),e(oo,Cc),e(kt,zc),b(No,kt,null),e(kt,Ac),b(Do,kt,null),g(o,ui,_),g(o,no,_),e(no,So),e(So,Ha),b(Vn,Ha,null),e(no,Ic),e(no,Ka),e(Ka,Lc),g(o,fi,_),g(o,ge,_),b(Xn,ge,null),e(ge,Oc),e(ge,Ra),e(Ra,Nc),e(ge,Dc),e(ge,Ks),e(Ks,Rs),e(Rs,Sc),e(Ks,Bc),e(ge,Wc),e(ge,yt),e(yt,Uc),e(yt,Va),e(Va,Qc),e(yt,Hc),e(yt,Xa),e(Xa,Kc),e(yt,Rc),e(yt,Ya),e(Ya,Vc),e(yt,Xc),e(yt,Za),e(Za,Yc),e(yt,Zc),e(ge,ep),e(ge,Yn),e(Yn,tp),e(Yn,Vs),e(Vs,op),e(Yn,np),e(ge,sp),e(ge,Zn),e(Zn,ap),e(Zn,es),e(es,rp),e(Zn,ip),e(ge,lp),b(Bo,ge,null),e(ge,dp),e(ge,lt),b(ts,lt,null),e(lt,cp),e(lt,so),e(so,pp),e(so,Xs),e(Xs,hp),e(so,up),e(so,er),e(er,fp),e(so,mp),e(lt,gp),b(Wo,lt,null),e(lt,_p),b(Uo,lt,null),e(lt,Tp),b(Qo,lt,null),g(o,mi,_),g(o,ao,_),e(ao,Ho),e(Ho,tr),b(os,tr,null),e(ao,yp),e(ao,or),e(or,vp),g(o,gi,_),g(o,Ue,_),b(ns,Ue,null),e(Ue,wp),e(Ue,ro),e(ro,kp),e(ro,nr),e(nr,bp),e(ro,$p),e(ro,sr),e(sr,Pp),e(ro,Fp),e(Ue,jp),e(Ue,ss),e(ss,Ep),e(ss,Ys),e(Ys,xp),e(ss,Gp),e(Ue,Mp),e(Ue,as),e(as,Jp),e(as,rs),e(rs,qp),e(as,Cp),e(Ue,zp),b(Ko,Ue,null),e(Ue,Ap),e(Ue,dt),b(is,dt,null),e(dt,Ip),e(dt,io),e(io,Lp),e(io,Zs),e(Zs,Op),e(io,Np),e(io,ar),e(ar,Dp),e(io,Sp),e(dt,Bp),b(Ro,dt,null),e(dt,Wp),b(Vo,dt,null),e(dt,Up),b(Xo,dt,null),g(o,_i,_),g(o,lo,_),e(lo,Yo),e(Yo,rr),b(ls,rr,null),e(lo,Qp),e(lo,ir),e(ir,Hp),g(o,Ti,_),g(o,Ie,_),b(ds,Ie,null),e(Ie,Kp),e(Ie,lr),e(lr,Rp),e(Ie,Vp),e(Ie,cs),e(cs,Xp),e(cs,ea),e(ea,Yp),e(cs,Zp),e(Ie,eh),e(Ie,ps),e(ps,th),e(ps,hs),e(hs,oh),e(ps,nh),e(Ie,sh),e(Ie,dr),e(dr,ah),e(Ie,rh),e(Ie,Jt),e(Jt,cr),e(cr,us),e(us,ih),e(Jt,lh),e(Jt,pr),e(pr,fs),e(fs,dh),e(Jt,ch),e(Jt,hr),e(hr,ms),e(ms,ph),e(Jt,hh),e(Jt,ur),e(ur,gs),e(gs,uh),e(Ie,fh),e(Ie,bt),b(_s,bt,null),e(bt,mh),e(bt,co),e(co,gh),e(co,fr),e(fr,_h),e(co,Th),e(co,mr),e(mr,yh),e(co,vh),e(bt,wh),b(Zo,bt,null),e(bt,kh),b(en,bt,null),g(o,yi,_),g(o,po,_),e(po,tn),e(tn,gr),b(Ts,gr,null),e(po,bh),e(po,_r),e(_r,$h),g(o,vi,_),g(o,Le,_),b(ys,Le,null),e(Le,Ph),e(Le,Tr),e(Tr,Fh),e(Le,jh),e(Le,vs),e(vs,Eh),e(vs,ta),e(ta,xh),e(vs,Gh),e(Le,Mh),e(Le,ws),e(ws,Jh),e(ws,ks),e(ks,qh),e(ws,Ch),e(Le,zh),e(Le,yr),e(yr,Ah),e(Le,Ih),e(Le,qt),e(qt,vr),e(vr,bs),e(bs,Lh),e(qt,Oh),e(qt,wr),e(wr,$s),e($s,Nh),e(qt,Dh),e(qt,kr),e(kr,Ps),e(Ps,Sh),e(qt,Bh),e(qt,br),e(br,Fs),e(Fs,Wh),e(Le,Uh),e(Le,$t),b(js,$t,null),e($t,Qh),e($t,ho),e(ho,Hh),e(ho,$r),e($r,Kh),e(ho,Rh),e(ho,Pr),e(Pr,Vh),e(ho,Xh),e($t,Yh),b(on,$t,null),e($t,Zh),b(nn,$t,null),wi=!0},p(o,[_]){const Es={};_&2&&(Es.$$scope={dirty:_,ctx:o}),go.$set(Es);const Fr={};_&2&&(Fr.$$scope={dirty:_,ctx:o}),To.$set(Fr);const jr={};_&2&&(jr.$$scope={dirty:_,ctx:o}),yo.$set(jr);const Er={};_&2&&(Er.$$scope={dirty:_,ctx:o}),vo.$set(Er);const xs={};_&2&&(xs.$$scope={dirty:_,ctx:o}),ko.$set(xs);const xr={};_&2&&(xr.$$scope={dirty:_,ctx:o}),bo.$set(xr);const Gr={};_&2&&(Gr.$$scope={dirty:_,ctx:o}),$o.$set(Gr);const Mr={};_&2&&(Mr.$$scope={dirty:_,ctx:o}),Fo.$set(Mr);const uo={};_&2&&(uo.$$scope={dirty:_,ctx:o}),jo.$set(uo);const Jr={};_&2&&(Jr.$$scope={dirty:_,ctx:o}),Eo.$set(Jr);const qr={};_&2&&(qr.$$scope={dirty:_,ctx:o}),xo.$set(qr);const Gs={};_&2&&(Gs.$$scope={dirty:_,ctx:o}),Mo.$set(Gs);const Cr={};_&2&&(Cr.$$scope={dirty:_,ctx:o}),Jo.$set(Cr);const zr={};_&2&&(zr.$$scope={dirty:_,ctx:o}),qo.$set(zr);const Ar={};_&2&&(Ar.$$scope={dirty:_,ctx:o}),zo.$set(Ar);const vt={};_&2&&(vt.$$scope={dirty:_,ctx:o}),Ao.$set(vt);const Ir={};_&2&&(Ir.$$scope={dirty:_,ctx:o}),Io.$set(Ir);const Lr={};_&2&&(Lr.$$scope={dirty:_,ctx:o}),Oo.$set(Lr);const Or={};_&2&&(Or.$$scope={dirty:_,ctx:o}),No.$set(Or);const Nr={};_&2&&(Nr.$$scope={dirty:_,ctx:o}),Do.$set(Nr);const Ms={};_&2&&(Ms.$$scope={dirty:_,ctx:o}),Bo.$set(Ms);const Dr={};_&2&&(Dr.$$scope={dirty:_,ctx:o}),Wo.$set(Dr);const oa={};_&2&&(oa.$$scope={dirty:_,ctx:o}),Uo.$set(oa);const Sr={};_&2&&(Sr.$$scope={dirty:_,ctx:o}),Qo.$set(Sr);const Br={};_&2&&(Br.$$scope={dirty:_,ctx:o}),Ko.$set(Br);const Ct={};_&2&&(Ct.$$scope={dirty:_,ctx:o}),Ro.$set(Ct);const Wr={};_&2&&(Wr.$$scope={dirty:_,ctx:o}),Vo.$set(Wr);const Ur={};_&2&&(Ur.$$scope={dirty:_,ctx:o}),Xo.$set(Ur);const Qr={};_&2&&(Qr.$$scope={dirty:_,ctx:o}),Zo.$set(Qr);const Js={};_&2&&(Js.$$scope={dirty:_,ctx:o}),en.$set(Js);const Hr={};_&2&&(Hr.$$scope={dirty:_,ctx:o}),on.$set(Hr);const Kr={};_&2&&(Kr.$$scope={dirty:_,ctx:o}),nn.$set(Kr)},i(o){wi||($(l.$$.fragment,o),$(E.$$.fragment,o),$(ee.$$.fragment,o),$(he.$$.fragment,o),$(un.$$.fragment,o),$(fn.$$.fragment,o),$(mn.$$.fragment,o),$(gn.$$.fragment,o),$(go.$$.fragment,o),$(Tn.$$.fragment,o),$(yn.$$.fragment,o),$(kn.$$.fragment,o),$(To.$$.fragment,o),$(yo.$$.fragment,o),$(vo.$$.fragment,o),$(bn.$$.fragment,o),$($n.$$.fragment,o),$(jn.$$.fragment,o),$(ko.$$.fragment,o),$(bo.$$.fragment,o),$($o.$$.fragment,o),$(En.$$.fragment,o),$(xn.$$.fragment,o),$(Jn.$$.fragment,o),$(Fo.$$.fragment,o),$(jo.$$.fragment,o),$(Eo.$$.fragment,o),$(xo.$$.fragment,o),$(qn.$$.fragment,o),$(Cn.$$.fragment,o),$(In.$$.fragment,o),$(Mo.$$.fragment,o),$(Jo.$$.fragment,o),$(qo.$$.fragment,o),$(Ln.$$.fragment,o),$(On.$$.fragment,o),$(zo.$$.fragment,o),$(Bn.$$.fragment,o),$(Ao.$$.fragment,o),$(Io.$$.fragment,o),$(Wn.$$.fragment,o),$(Un.$$.fragment,o),$(Oo.$$.fragment,o),$(Rn.$$.fragment,o),$(No.$$.fragment,o),$(Do.$$.fragment,o),$(Vn.$$.fragment,o),$(Xn.$$.fragment,o),$(Bo.$$.fragment,o),$(ts.$$.fragment,o),$(Wo.$$.fragment,o),$(Uo.$$.fragment,o),$(Qo.$$.fragment,o),$(os.$$.fragment,o),$(ns.$$.fragment,o),$(Ko.$$.fragment,o),$(is.$$.fragment,o),$(Ro.$$.fragment,o),$(Vo.$$.fragment,o),$(Xo.$$.fragment,o),$(ls.$$.fragment,o),$(ds.$$.fragment,o),$(_s.$$.fragment,o),$(Zo.$$.fragment,o),$(en.$$.fragment,o),$(Ts.$$.fragment,o),$(ys.$$.fragment,o),$(js.$$.fragment,o),$(on.$$.fragment,o),$(nn.$$.fragment,o),wi=!0)},o(o){P(l.$$.fragment,o),P(E.$$.fragment,o),P(ee.$$.fragment,o),P(he.$$.fragment,o),P(un.$$.fragment,o),P(fn.$$.fragment,o),P(mn.$$.fragment,o),P(gn.$$.fragment,o),P(go.$$.fragment,o),P(Tn.$$.fragment,o),P(yn.$$.fragment,o),P(kn.$$.fragment,o),P(To.$$.fragment,o),P(yo.$$.fragment,o),P(vo.$$.fragment,o),P(bn.$$.fragment,o),P($n.$$.fragment,o),P(jn.$$.fragment,o),P(ko.$$.fragment,o),P(bo.$$.fragment,o),P($o.$$.fragment,o),P(En.$$.fragment,o),P(xn.$$.fragment,o),P(Jn.$$.fragment,o),P(Fo.$$.fragment,o),P(jo.$$.fragment,o),P(Eo.$$.fragment,o),P(xo.$$.fragment,o),P(qn.$$.fragment,o),P(Cn.$$.fragment,o),P(In.$$.fragment,o),P(Mo.$$.fragment,o),P(Jo.$$.fragment,o),P(qo.$$.fragment,o),P(Ln.$$.fragment,o),P(On.$$.fragment,o),P(zo.$$.fragment,o),P(Bn.$$.fragment,o),P(Ao.$$.fragment,o),P(Io.$$.fragment,o),P(Wn.$$.fragment,o),P(Un.$$.fragment,o),P(Oo.$$.fragment,o),P(Rn.$$.fragment,o),P(No.$$.fragment,o),P(Do.$$.fragment,o),P(Vn.$$.fragment,o),P(Xn.$$.fragment,o),P(Bo.$$.fragment,o),P(ts.$$.fragment,o),P(Wo.$$.fragment,o),P(Uo.$$.fragment,o),P(Qo.$$.fragment,o),P(os.$$.fragment,o),P(ns.$$.fragment,o),P(Ko.$$.fragment,o),P(is.$$.fragment,o),P(Ro.$$.fragment,o),P(Vo.$$.fragment,o),P(Xo.$$.fragment,o),P(ls.$$.fragment,o),P(ds.$$.fragment,o),P(_s.$$.fragment,o),P(Zo.$$.fragment,o),P(en.$$.fragment,o),P(Ts.$$.fragment,o),P(ys.$$.fragment,o),P(js.$$.fragment,o),P(on.$$.fragment,o),P(nn.$$.fragment,o),wi=!1},d(o){t(d),o&&t(y),o&&t(p),F(l),o&&t(J),o&&t(C),F(E),o&&t(Te),o&&t(B),o&&t(ye),o&&t(Q),o&&t(A),o&&t(ue),o&&t(ve),o&&t(fe),o&&t(we),F(ee,o),o&&t(I),o&&t(ae),o&&t(He),o&&t(U),F(he),o&&t(Rr),o&&t(fo),o&&t(Vr),F(un,o),o&&t(Xr),o&&t(Cs),o&&t(Yr),F(fn,o),o&&t(Zr),o&&t(Bt),F(mn),o&&t(ei),o&&t(Gt),F(gn),F(go),o&&t(ti),o&&t(Wt),F(Tn),o&&t(oi),o&&t(Mt),F(yn),F(kn),F(To),F(yo),F(vo),o&&t(ni),o&&t(Qt),F(bn),o&&t(si),o&&t(gt),F($n),F(jn),F(ko),F(bo),F($o),o&&t(ai),o&&t(Kt),F(En),o&&t(ri),o&&t(Se),F(xn),F(Jn),F(Fo),F(jo),F(Eo),F(xo),o&&t(ii),o&&t(Vt),F(qn),o&&t(li),o&&t(Tt),F(Cn),F(In),F(Mo),F(Jo),F(qo),o&&t(di),o&&t(Zt),F(Ln),o&&t(ci),o&&t(Be),F(On),F(zo),F(Bn),F(Ao),F(Io),o&&t(pi),o&&t(to),F(Wn),o&&t(hi),o&&t(We),F(Un),F(Oo),F(Rn),F(No),F(Do),o&&t(ui),o&&t(no),F(Vn),o&&t(fi),o&&t(ge),F(Xn),F(Bo),F(ts),F(Wo),F(Uo),F(Qo),o&&t(mi),o&&t(ao),F(os),o&&t(gi),o&&t(Ue),F(ns),F(Ko),F(is),F(Ro),F(Vo),F(Xo),o&&t(_i),o&&t(lo),F(ls),o&&t(Ti),o&&t(Ie),F(ds),F(_s),F(Zo),F(en),o&&t(yi),o&&t(po),F(Ts),o&&t(vi),o&&t(Le),F(ys),F(js),F(on),F(nn)}}}const Km={local:"gptj",sections:[{local:"overview",sections:[{local:"generation",title:"Generation"}],title:"Overview"},{local:"transformers.GPTJConfig",title:"GPTJConfig"},{local:"transformers.GPTJModel",title:"GPTJModel"},{local:"transformers.GPTJForCausalLM",title:"GPTJForCausalLM"},{local:"transformers.GPTJForSequenceClassification",title:"GPTJForSequenceClassification"},{local:"transformers.GPTJForQuestionAnswering",title:"GPTJForQuestionAnswering"},{local:"transformers.TFGPTJModel",title:"TFGPTJModel"},{local:"transformers.TFGPTJForCausalLM",title:"TFGPTJForCausalLM"},{local:"transformers.TFGPTJForSequenceClassification",title:"TFGPTJForSequenceClassification"},{local:"transformers.TFGPTJForQuestionAnswering",title:"TFGPTJForQuestionAnswering"},{local:"transformers.FlaxGPTJModel",title:"FlaxGPTJModel"},{local:"transformers.FlaxGPTJForCausalLM",title:"FlaxGPTJForCausalLM"}],title:"GPT-J"};function Rm(x){return fm(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class og extends cm{constructor(d){super();pm(this,d,Rm,Hm,hm,{})}}export{og as default,Km as metadata};
